import React, { Fragment as Fragment$1, useState, useRef, useEffect, createContext, useContext, useCallback, forwardRef, Children } from 'react';
import { makeStyles, Card, CardContent, Typography, Button, Dialog, DialogTitle, DialogContent, DialogContentText, DialogActions, IconButton, lighten, Avatar, Tooltip, Drawer, ButtonBase, TextField, Checkbox, withStyles, Switch, useTheme, Link as Link$1, Breadcrumbs, MenuItem, Box, Divider, FormControl, Input as Input$1, InputAdornment, Toolbar, Paper, Chip, ListItem, createStyles, Collapse, List, ListItemIcon, ListItemText, Badge, CardActions, Menu, CircularProgress, colors, Grid as Grid$1, LinearProgress, Fade, Container, useMediaQuery, AppBar } from '@material-ui/core';
import { Link, Route, NavLink } from 'react-router-dom';
import { FluentButton as FluentButton$1, FluentIconButton as FluentIconButton$1, FluentTextField as FluentTextField$1, AvatarAlphabet as AvatarAlphabet$1, FluentCard as FluentCard$1, LayoutUnit as LayoutUnit$1, StatusChip as StatusChip$1, StandardTitle as StandardTitle$1, FluentSimpleTabs as FluentSimpleTabs$1, FluentSimpleTab as FluentSimpleTab$1, AppMenu as AppMenu$1, BreadCrumbMenu as BreadCrumbMenu$1, UtilityBar as UtilityBar$1 } from 'unity-fluent-library-demo';
import * as Icons from '@fluentui/react-icons';
import { ChromeCloseIcon, CheckboxIcon, CheckboxCompositeReversedIcon, ChevronDownIcon, ChevronRightIcon, ViewDashboardIcon, AdminALogo32Icon, MessageIcon, ContentFeedIcon, RawSourceIcon, BugIcon, OfficeFormsLogo16Icon, CloudUploadIcon, MapPinIcon, ZoomIcon, ZoomInIcon, ZoomOutIcon, ZoomToFitIcon, POIIcon, SearchIcon, AlertSolidIcon, HomeIcon, BoxMultiplySolidIcon, ChevronLeftIcon, ChevronUpIcon, DeleteIcon, CopyIcon, CheckMarkIcon, ChevronDownMedIcon, MoreIcon, MarketDownIcon, MarketIcon, NumberedListIcon, ChartIcon, WaffleIcon } from '@fluentui/react-icons';
import TimeAgo from 'timeago-react';
import Button$1 from '@material-ui/core/Button';
import { makeStyles as makeStyles$1 } from '@material-ui/core/styles';
import Autocomplete from '@material-ui/lab/Autocomplete';
import TreeView from '@material-ui/lab/TreeView';
import TreeItem from '@material-ui/lab/TreeItem';
import Typography$1 from '@material-ui/core/Typography';
import Tab from '@material-ui/core/Tab';
import Tabs from '@material-ui/core/Tabs';
import { View, Map as Map$2 } from 'ol';
import { defaults, DragRotateAndZoom, Select } from 'ol/interaction';
import OLVectorLayer from 'ol/layer/Vector';
import OLTileLayer from 'ol/layer/Tile';
import OLImageLayer from 'ol/layer/Image';
import { OSM } from 'ol/source';
import { fromLonLat } from 'ol/proj';
import { FullScreen } from 'ol/control';
import Grid from '@material-ui/core/Grid';
import Slider from '@material-ui/core/Slider';
import Input from '@material-ui/core/Input';
import BingMaps from 'ol/source/BingMaps';
import 'ol/ol.css';
import { Style, Icon } from 'ol/style';
import { click } from 'ol/events/condition';
import { CopyToClipboard } from 'react-copy-to-clipboard';
import { createTeleporter } from 'react-teleporter';
import { MuiVegaLite } from '@material-vega/material-ui';
import warning from 'warning';
import useConstant from 'use-constant';
import round from '@extra-number/round';
import DownArrow from '@material-ui/icons/ArrowDownward';
import UpArrow from '@material-ui/icons/ArrowUpward';
import ToggleButton from '@material-ui/lab/ToggleButton';
import ToggleButtonGroup from '@material-ui/lab/ToggleButtonGroup';
import { Sparklines, SparklinesLine } from 'react-sparklines';
import MuiExpansionPanel from '@material-ui/core/ExpansionPanel';
import MuiExpansionPanelSummary from '@material-ui/core/ExpansionPanelSummary';
import MuiExpansionPanelDetails from '@material-ui/core/ExpansionPanelDetails';
import { useTranslation } from 'react-i18next';

var useStyles = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    },
    card: {
      background: theme.palette.primary.main
    },
    content: {
      color: theme.palette.getContrastText(theme.palette.primary.main)
    },
    header: {
      textAlign: 'center'
    },
    subHeader: {
      marginTop: theme.spacing(-3)
    },
    button: {
      marginTop: theme.spacing(8),
      display: 'flex',
      justifyContent: 'center'
    },
    largeDisplay: {
      fontSize: '4rem',
      color: theme.palette.getContrastText(theme.palette.primary.main)
    },
    message: {
      marginTop: theme.spacing(3)
    }
  };
});
var PageNotFound = function PageNotFound(props) {
  var classes = useStyles();
  var title = props.title,
      subheader = props.subheader,
      message = props.message,
      to = props.to,
      buttonLabel = props.buttonLabel;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(Card, {
    className: classes.card
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("div", {
    className: classes.content
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.header
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Typography, {
    className: classes.largeDisplay
  }, "404")), /*#__PURE__*/React.createElement("div", {
    className: classes.subHeader
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "h6"
  }, title))), /*#__PURE__*/React.createElement("div", {
    className: classes.message
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "overline",
    style: {
      fontWeight: 700
    }
  }, subheader), /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: 'left'
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, message))), /*#__PURE__*/React.createElement("div", {
    className: classes.button
  }, /*#__PURE__*/React.createElement(Button, {
    component: Link,
    to: to,
    variant: "contained",
    color: "secondary"
  }, buttonLabel))))));
};

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var useStyles$1 = makeStyles(function (theme) {
  return {
    root: {},
    paper: {
      borderRadius: 2,
      borderTop: function borderTop(props) {
        return props.header && "4px solid " + theme.palette.secondary.main;
      }
    },
    title: {
      color: function color(props) {
        return props.header && theme.palette.secondary.main;
      }
    },
    actions: {
      marginBottom: 16,
      marginRight: 16
    }
  };
});
var FluentDialog = function FluentDialog(props) {
  var classes = useStyles$1(props);

  var title = props.title,
      message = props.message,
      actionOne = props.actionOne,
      actionTwo = props.actionTwo,
      labelOne = props.labelOne,
      labelTwo = props.labelTwo,
      open = props.open,
      handleClose = props.handleClose,
      ariaLabelledby = props.ariaLabelledby,
      ariaDescribedby = props.ariaDescribedby,
      titleId = props.titleId,
      descriptionId = props.descriptionId,
      children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["title", "message", "actionOne", "actionTwo", "labelOne", "labelTwo", "open", "handleClose", "ariaLabelledby", "ariaDescribedby", "titleId", "descriptionId", "children"]);

  return /*#__PURE__*/React.createElement(Dialog, _extends({
    open: open,
    onClose: handleClose,
    "aria-labelledby": ariaLabelledby,
    "aria-describedby": ariaDescribedby
  }, otherProps, {
    classes: {
      paper: classes.paper
    }
  }), /*#__PURE__*/React.createElement(DialogTitle, {
    className: classes.title,
    id: titleId
  }, title), /*#__PURE__*/React.createElement(DialogContent, null, /*#__PURE__*/React.createElement(DialogContentText, {
    id: descriptionId
  }, message), children), /*#__PURE__*/React.createElement(DialogActions, {
    className: classes.actions
  }, /*#__PURE__*/React.createElement(FluentButton$1, {
    onClick: actionOne,
    variant: "contained",
    color: "secondary"
  }, labelOne), /*#__PURE__*/React.createElement(FluentButton$1, {
    onClick: actionTwo,
    variant: "outlined",
    color: "primary"
  }, labelTwo)));
};

var useStyles$2 = makeStyles(function (theme) {
  return {
    root: {
      marginTop: theme.spacing(1),
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    }
  };
});
var StandardTitle = function StandardTitle(props) {
  var classes = useStyles$2();

  var children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(Typography, _extends({
    component: "h2",
    variant: "h6",
    gutterBottom: true,
    className: classes.root
  }, other), children);
};

function toVal(mix) {
	var k, y, str='';

	if (typeof mix === 'string' || typeof mix === 'number') {
		str += mix;
	} else if (typeof mix === 'object') {
		if (Array.isArray(mix)) {
			for (k=0; k < mix.length; k++) {
				if (mix[k]) {
					if (y = toVal(mix[k])) {
						str && (str += ' ');
						str += y;
					}
				}
			}
		} else {
			for (k in mix) {
				if (mix[k]) {
					str && (str += ' ');
					str += k;
				}
			}
		}
	}

	return str;
}

function clsx () {
	var i=0, tmp, x, str='';
	while (i < arguments.length) {
		if (tmp = arguments[i++]) {
			if (x = toVal(tmp)) {
				str && (str += ' ');
				str += x;
			}
		}
	}
	return str;
}

var useStyles$3 = makeStyles({
  root: {
    display: 'inline-block',
    '& > svg': {
      display: 'inherit'
    }
  },
  "default": {
    fontSize: 18,
    width: 18,
    height: 18
  },
  large: {
    fontSize: 24,
    width: 24,
    height: 24
  },
  medium: {
    fontSize: 16,
    width: 16,
    height: 16
  },
  small: {
    fontSize: 14,
    width: 14,
    height: 14
  }
}, {
  name: 'FluentIcon'
});
var FluentIcon = function FluentIcon(props) {
  var classes = useStyles$3(props);

  var IconComponent = props.component,
      _props$size = props.size,
      size = _props$size === void 0 ? 'default' : _props$size,
      className = props.className,
      otherProps = _objectWithoutPropertiesLoose(props, ["component", "size", "className"]);

  return /*#__PURE__*/React.createElement(IconComponent, _extends({}, otherProps, {
    className: clsx(classes.root, className, classes[size])
  }));
};

var useStyles$4 = makeStyles({
  root: {
    borderRadius: 2,
    width: 32,
    height: 32
  }
});
var FluentIconButton = function FluentIconButton(props) {
  var classes = useStyles$4(props);

  var icon = props.icon,
      otherProps = _objectWithoutPropertiesLoose(props, ["icon"]);

  return /*#__PURE__*/React.createElement(IconButton, _extends({}, otherProps, {
    classes: {
      root: classes.root
    }
  }), /*#__PURE__*/React.createElement(FluentIcon, {
    component: icon,
    size: "medium"
  }));
};

var useStyles$5 = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row',
      padding: theme.spacing(2)
    },
    title: {
      flex: 1
    }
  };
});
var SideSheetHeader = function SideSheetHeader(props) {
  var classes = useStyles$5();
  var title = props.title,
      onClose = props.onClose;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(StandardTitle, {
    className: classes.title
  }, title), /*#__PURE__*/React.createElement(FluentIconButton, {
    icon: ChromeCloseIcon,
    onClick: onClose
  }));
};

var useStyles$6 = makeStyles(function (theme) {
  return {
    root: {
      fontWeight: 500
    },
    header: {
      fontSize: 18
    },
    subHeader: {
      fontSize: 14,
      color: lighten(theme.palette.common.black, 0.5)
    }
  };
});
var FormHeader = function FormHeader(props) {
  var children = props.children;
  var classes = useStyles$6();
  return /*#__PURE__*/React.createElement(Typography, {
    className: clsx(classes.header, classes.root)
  }, children);
};
var FormSubHeader = function FormSubHeader(props) {
  var children = props.children;
  var classes = useStyles$6();
  return /*#__PURE__*/React.createElement(Typography, {
    className: clsx(classes.subHeader, classes.root)
  }, children);
};

var useStyles$7 = makeStyles(function (theme) {
  return {
    small: {
      width: 20,
      height: 20,
      fontSize: 14,
      marginLeft: 2
    },
    medium: {
      width: 35,
      height: 35,
      fontSize: 16,
      paddingTop: 2
    }
  };
});
var AvatarAlphabet = function AvatarAlphabet(props) {
  var letter = '';
  var avatarCharacter = props.avatarCharacter,
      size = props.size;
  var classes = useStyles$7();

  switch (avatarCharacter) {
    case 'A':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#FFB900'
        }
      }, "A");
      break;

    case 'B':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#E74856'
        }
      }, "B");
      break;

    case 'C':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#0078D7'
        }
      }, "C");
      break;

    case 'D':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#0099BC'
        }
      }, "D");
      break;

    case 'E':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#7A7574'
        }
      }, "E");
      break;

    case 'F':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#767676'
        }
      }, "F");
      break;

    case 'G':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#FF8C00'
        }
      }, "G");
      break;

    case 'H':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#E81123'
        }
      }, "H");
      break;

    case 'I':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#0063B1'
        }
      }, "I");
      break;

    case 'J':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#2D7D9A'
        }
      }, "J");
      break;

    case 'K':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#5D5A58'
        }
      }, "K");
      break;

    case 'L':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#4C4A48'
        }
      }, "L");
      break;

    case 'M':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#F7630C'
        }
      }, "M");
      break;

    case 'N':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#EA005E'
        }
      }, "N");
      break;

    case 'O':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#8E8CD8'
        }
      }, "O");
      break;

    case 'P':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#00B7C3'
        }
      }, "P");
      break;

    case 'Q':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#68768A'
        }
      }, "Q");
      break;

    case 'R':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#69797E'
        }
      }, "R");
      break;

    case 'S':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#CA5010'
        }
      }, "S");
      break;

    case 'T':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#C30052'
        }
      }, "T");
      break;

    case 'U':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: 'FF4343'
        }
      }, "U");
      break;

    case 'V':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#9A0089'
        }
      }, "V");
      break;

    case 'W':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#10893E'
        }
      }, "W");
      break;

    case 'X':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#567C73'
        }
      }, "X");
      break;

    case 'Y':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#018574'
        }
      }, "Y");
      break;

    case 'Z':
      letter = /*#__PURE__*/React.createElement(Avatar, {
        className: size === 'small' ? classes.small : classes.medium,
        style: {
          backgroundColor: '#881798'
        }
      }, "Z");
      break;
  }

  return letter;
};

var useStyles$8 = makeStyles(function (theme) {
  return {
    root: {
      marginBottom: theme.spacing(2)
    },
    topRow: {
      display: 'flex'
    },
    desc: {
      marginLeft: theme.spacing(0.5)
    },
    indent: {
      marginLeft: function marginLeft(props) {
        return props.avatarDisplay ? theme.spacing(6) : theme.spacing(4);
      }
    },
    indentChildren: {
      marginLeft: function marginLeft(props) {
        return props.avatarDisplay ? theme.spacing(2) : 0;
      },
      marginTop: function marginTop(props) {
        return props.avatarDisplay ? theme.spacing(-1.5) : 0;
      }
    },
    timestamp: {
      color: lighten(theme.palette.common.black, 0.5),
      marginTop: theme.spacing(-3)
    },
    actionUser: {
      marginRight: 10,
      marginLeft: 11
    },
    activityIcon: {
      marginTop: 2
    },
    action: {
      verticalAlign: 'text-bottom',
      lineHeight: 1.8
    },
    avatar: {
      width: 35,
      height: 35,
      textTransform: 'uppercase'
    }
  };
});
var FluentActivity = function FluentActivity(props) {
  var classes = useStyles$8(props);
  var activityIcon = props.activityIcon,
      avatar = props.avatar,
      avatarAlt = props.avatarAlt,
      timeStamp = props.timeStamp,
      children = props.children,
      action = props.action,
      actionUser = props.actionUser,
      avatarDisplay = props.avatarDisplay;

  var getUser = function getUser(userEmail) {
    var _matches$1$trim;

    var regex = />(.*)</g;
    var matches = regex.exec(userEmail);
    return ((_matches$1$trim = matches[1].trim()) === null || _matches$1$trim === void 0 ? void 0 : _matches$1$trim.charAt(0)) || '?';
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.topRow
  }, activityIcon && /*#__PURE__*/React.createElement("div", {
    className: classes.activityIcon
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: activityIcon
  })), avatarDisplay && avatar && /*#__PURE__*/React.createElement("div", {
    className: classes.avatarContainer
  }, /*#__PURE__*/React.createElement(Avatar, {
    alt: avatarAlt,
    className: classes.avatar,
    src: avatar
  })), avatarDisplay && !avatar && /*#__PURE__*/React.createElement("div", {
    className: classes.avatarContainer
  }, /*#__PURE__*/React.createElement(AvatarAlphabet, {
    alt: avatarAlt,
    className: classes.avatar,
    avatarCharacter: getUser(actionUser.props.children[0].props.jsx).toUpperCase()
  }, getUser(actionUser.props.children[0].props.jsx))), /*#__PURE__*/React.createElement("div", {
    className: classes.actionUser
  }, actionUser), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption",
    className: classes.action
  }, action)), /*#__PURE__*/React.createElement("div", {
    className: classes.indentChildren
  }, children), /*#__PURE__*/React.createElement("div", {
    className: classes.time
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption",
    className: clsx(classes.indent, classes.timestamp)
  }, /*#__PURE__*/React.createElement(Tooltip, {
    title: timeStamp
  }, /*#__PURE__*/React.createElement(TimeAgo, {
    datetime: timeStamp
  })))));
};

var FluentActivityRow = function FluentActivityRow(props) {
  var children = props.children;
  return /*#__PURE__*/React.createElement("div", {
    style: {
      marginLeft: 30
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, children));
};

var useStyles$9 = makeStyles(function (theme) {
  return {
    paper: {
      width: function width(props) {
        return props.width || 320;
      }
    }
  };
});
var BaseSideSheet = function BaseSideSheet(props) {
  var classes = useStyles$9(props);

  var children = props.children,
      onClose = props.onClose,
      noBackdrop = props.noBackdrop,
      drawerProps = _objectWithoutPropertiesLoose(props, ["width", "children", "onClose", "noBackdrop"]);

  return /*#__PURE__*/React.createElement(Drawer, _extends({
    classes: classes,
    variant: "temporary",
    anchor: "right",
    onClose: onClose
  }, drawerProps, {
    BackdropProps: {
      invisible: noBackdrop
    }
  }), children);
};
var SideSheet = function SideSheet(props) {
  var children = props.children,
      title = props.title,
      otherProps = _objectWithoutPropertiesLoose(props, ["children", "title"]);

  var onClose = props.onClose;
  return /*#__PURE__*/React.createElement(BaseSideSheet, otherProps, /*#__PURE__*/React.createElement(SideSheetHeader, {
    onClose: onClose,
    title: title
  }), /*#__PURE__*/React.createElement(CardContent, null, " ", children));
};

var useStyles$a = makeStyles(function (theme) {
  return {
    root: {
      borderRadius: 2,
      height: 32,
      padding: '0 16px',
      minWidth: 80,
      border: function border(props) {
        return "1px solid " + props.color;
      }
    },
    label: {
      textTransform: 'capitalize',
      fontSize: '0.875rem',
      fontWeight: 600
    }
  };
});
var FluentButton = function FluentButton(props) {
  var classes = useStyles$a(props);

  var children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(Button$1, _extends({}, otherProps, {
    disableElevation: true,
    classes: {
      root: classes.root,
      label: classes.label
    },
    margin: "dense"
  }), children);
};

var useStyles$b = makeStyles({
  root: {
    borderRadius: 2,
    minHeight: 72,
    padding: '0 16px',
    minWidth: 80,
    border: function border(props) {
      return "1px solid " + props.color;
    }
  },
  label: {
    textTransform: 'capitalize',
    fontSize: '0.875rem',
    fontWeight: 600,
    textAlign: 'left'
  }
});
var FluentCompoundButton = function FluentCompoundButton(props) {
  var classes = useStyles$b(props);

  var children = props.children,
      textSecondary = props.textSecondary,
      otherProps = _objectWithoutPropertiesLoose(props, ["children", "textSecondary"]);

  return /*#__PURE__*/React.createElement(Button$1, _extends({}, otherProps, {
    disableElevation: true,
    classes: {
      root: classes.root,
      label: classes.label
    }
  }), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, children), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, textSecondary))));
};

var useStyles$c = makeStyles(function (theme) {
  return {
    root: {},
    wrapper: {
      display: 'flex',
      flexDirection: 'row',
      marginRight: theme.spacing(2)
    },
    icon: {
      fontSize: 16,
      width: 16,
      height: 16,
      color: theme.palette.secondary.main
    },
    label: {
      marginLeft: theme.spacing(1),
      fontSize: '0.875rem',
      '&:hover': {
        color: theme.palette.secondary.main
      }
    }
  };
}, {
  name: 'ToolBarButton'
});
var ToolBarButton = function ToolBarButton(props) {
  var classes = useStyles$c();
  var ToolBarComponent = props.component,
      click = props.click,
      label = props.label;
  return /*#__PURE__*/React.createElement(ButtonBase, {
    classes: {
      root: classes.root
    },
    className: classes.wrapper,
    onClick: click,
    disableRipple: true
  }, /*#__PURE__*/React.createElement(ToolBarComponent, {
    className: classes.icon
  }), /*#__PURE__*/React.createElement(Typography, {
    variant: "body2",
    className: classes.label
  }, label));
};

var useStyles$d = makeStyles$1(function (theme) {
  return {
    root: {
      '& > *': {
        margin: theme.spacing(1)
      }
    },
    input: {
      display: 'none'
    }
  };
});
var FluentUploadButton = function FluentUploadButton(props) {
  var classes = useStyles$d();
  var color = props.color,
      label = props.label,
      accept = props.accept,
      id = props.id,
      onChange = props.onChange,
      onClick = props.onClick,
      variant = props.variant;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("input", {
    accept: accept,
    className: classes.input,
    id: id,
    multiple: true,
    type: "file",
    onChange: onChange
  }), /*#__PURE__*/React.createElement("label", {
    htmlFor: id
  }, /*#__PURE__*/React.createElement(FluentButton$1, {
    onClick: onClick,
    variant: variant,
    color: color,
    component: "span"
  }, label)), /*#__PURE__*/React.createElement("input", {
    accept: accept,
    className: classes.input,
    id: id,
    type: "file"
  }));
};

var useStyles$e = makeStyles$1(function (theme) {
  return {
    root: {
      '& > *': {
        margin: theme.spacing(1)
      }
    },
    input: {
      display: 'none'
    }
  };
});
var FluentUploadIconButton = function FluentUploadIconButton(props) {
  var classes = useStyles$e();
  var color = props.color,
      icon = props.icon,
      aria = props.aria,
      accept = props.accept,
      id = props.id,
      onChange = props.onChange,
      onClick = props.onClick;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("input", {
    accept: accept,
    className: classes.input,
    id: id,
    type: "file",
    onChange: onChange
  }), /*#__PURE__*/React.createElement("label", {
    htmlFor: id
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    icon: icon,
    color: color,
    "aria-label": aria,
    id: id,
    component: "span",
    onClick: onClick
  })), /*#__PURE__*/React.createElement("input", {
    accept: accept,
    className: classes.input,
    id: id,
    type: "file"
  }));
};

var useStyles$f = makeStyles(function (theme) {
  return {
    input: {
      borderRadius: 2,
      height: 32,
      padding: 0,
      marginTop: 3
    },
    formTextInput: {
      fontSize: 14
    },
    labelRoot: {
      fontSize: 14
    },
    FormControl: {
      display: 'none',
      marginTop: 0
    },
    label: {
      display: 'none'
    }
  };
});
var FluentTextField = function FluentTextField(props) {
  var classes = useStyles$f(props);

  var id = props.id,
      label = props.label,
      otherProps = _objectWithoutPropertiesLoose(props, ["children", "id", "label"]);

  return /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, label)), /*#__PURE__*/React.createElement(TextField, _extends({
    style: {
      marginTop: -2
    }
  }, otherProps, {
    id: id,
    variant: "outlined",
    size: "small",
    margin: "dense",
    InputProps: {
      classes: {
        root: classes.input,
        input: classes.formTextInput,
        label: classes.label
      }
    },
    InputLabelProps: {
      shrink: false,
      classes: {
        root: classes.labelRoot,
        focused: classes.labelFocused
      }
    }
  })));
};

var useStyles$g = makeStyles(function (theme) {
  return {
    box: {
      fontSize: 18,
      color: function color(props) {
        return props.primary ? theme.palette.primary.main : theme.palette.secondary.main;
      }
    }
  };
});
var FluentCheckbox = function FluentCheckbox(props) {
  var classes = useStyles$g(props);
  var name = props.name,
      checked = props.checked,
      onChange = props.onChange,
      aria = props.aria;

  for (var _len = arguments.length, otherProps = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    otherProps[_key - 1] = arguments[_key];
  }

  return /*#__PURE__*/React.createElement(Checkbox, _extends({}, otherProps, {
    name: name,
    icon: /*#__PURE__*/React.createElement(CheckboxIcon, {
      className: classes.box
    }),
    checkedIcon: /*#__PURE__*/React.createElement(CheckboxCompositeReversedIcon, {
      className: classes.box
    }),
    checked: checked,
    inputProps: {
      'aria-label': {
        aria: aria
      }
    },
    onChange: onChange
  }));
};

var FluentSwitch = withStyles(function (theme) {
  return {
    root: {
      width: 40,
      height: 20,
      padding: 0,
      display: 'flex'
    },
    switchBase: {
      padding: 4,
      color: theme.palette.grey[500],
      '&$checked': {
        transform: 'translateX(20px)',
        color: theme.palette.common.white,
        '& + $track': {
          opacity: 1,
          borderColor: theme.palette.primary.main
        }
      }
    },
    thumb: {
      width: 12,
      height: 12,
      boxShadow: 'none'
    },
    track: {
      border: "1px solid " + theme.palette.grey[500],
      borderRadius: 20 / 2,
      opacity: 1,
      backgroundColor: theme.palette.common.white
    },
    checked: {}
  };
})(Switch);
var FluentToggle = function FluentToggle(props) {
  var name = props.name,
      onChange = props.onChange,
      checked = props.checked,
      otherProps = _objectWithoutPropertiesLoose(props, ["name", "onChange", "checked"]);

  return /*#__PURE__*/React.createElement(FluentSwitch, _extends({}, otherProps, {
    checked: checked,
    onChange: onChange,
    name: name
  }));
};

var useStyles$h = makeStyles(function (theme) {
  return {
    root: {
      textDecoration: 'none',
      '& > * + *': {
        marginLeft: theme.spacing(2)
      }
    },
    link: {
      textDecoration: 'none',
      fontWeight: 700
    }
  };
});
var FluentLink = function FluentLink(props) {
  var children = props.children,
      activeClassName = props.activeClassName,
      to = props.to,
      linkColor = props.linkColor,
      otherProps = _objectWithoutPropertiesLoose(props, ["icon", "alt", "label", "children", "activeClassName", "to", "linkColor"]);

  var theme = useTheme();
  var classes = useStyles$h();
  return to && to.substring(0, 4) !== 'http' ? /*#__PURE__*/React.createElement(Link, {
    to: to,
    activeClassName: activeClassName,
    className: classes.link,
    style: {
      color: linkColor === 'primary' ? theme.palette.primary.main : theme.palette.secondary.main
    }
  }, children) : /*#__PURE__*/React.createElement(Typography, {
    component: "div",
    className: classes.root
  }, /*#__PURE__*/React.createElement(Link$1, _extends({}, otherProps, {
    href: to,
    color: linkColor,
    variant: "body1",
    style: {
      textDecoration: 'none'
    }
  }), children));
};

var useStyles$i = makeStyles(function (theme) {
  return {
    link: {
      textDecoration: 'none',
      color: function color(props) {
        return props.color === 'primary' ? theme.palette.getContrastText(theme.palette.primary.main) : theme.palette.getContrastText(theme.palette.secondary.main);
      }
    }
  };
});
var BreadCrumbMenu = function BreadCrumbMenu(props) {
  var classes = useStyles$i(props);
  var root = props.root;
  return /*#__PURE__*/React.createElement(Route, null, function (_ref) {
    var location = _ref.location;
    var pathnames = location.pathname.split('/').filter(function (x) {
      return x;
    });
    return /*#__PURE__*/React.createElement(Breadcrumbs, {
      "aria-label": "Breadcrumb"
    }, /*#__PURE__*/React.createElement(Link, {
      color: "inherit",
      to: "/",
      className: classes.link
    }, root), pathnames.map(function (value, index) {
      var last = index === pathnames.length - 1;
      var to = "/" + pathnames.slice(0, index + 1).join('/');
      var capitalValue = value[0].toUpperCase() + value.slice(1);
      return last ? /*#__PURE__*/React.createElement(Typography, {
        className: classes.link,
        key: to
      }, capitalValue) : /*#__PURE__*/React.createElement(Link, {
        to: to,
        key: to,
        className: classes.link
      }, capitalValue);
    }));
  });
};

var useStyles$j = makeStyles(function (theme) {
  return {
    textField: {
      marginLeft: theme.spacing(1),
      marginRight: theme.spacing(1)
    },
    dense: {
      marginTop: theme.spacing(1)
    },
    input: {
      borderRadius: 2,
      height: 32,
      padding: 0,
      marginTop: 3
    },
    formTextInput: {
      fontSize: 14
    },
    labelRoot: {
      fontSize: 14
    }
  };
});
var FluentSelectMenu = function FluentSelectMenu(_ref) {
  var data = _ref.data,
      handleChange = _ref.handleChange,
      label = _ref.label,
      id = _ref.id;
  var classes = useStyles$j();
  return /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement(TextField, {
    id: id,
    select: true,
    label: label,
    className: classes.textField,
    value: label,
    onChange: handleChange,
    size: "small",
    InputProps: {
      classes: {
        root: classes.input,
        input: classes.formTextInput,
        label: classes.label
      }
    },
    InputLabelProps: {
      shrink: false,
      classes: {
        root: classes.labelRoot,
        focused: classes.labelFocused
      }
    },
    SelectProps: {
      MenuProps: {
        className: classes.menu
      }
    },
    margin: "normal",
    variant: "outlined"
  }, data && data.map(function (option) {
    return /*#__PURE__*/React.createElement(MenuItem, {
      className: classes.labelRoot,
      key: option.value,
      value: option.value
    }, option.label);
  })));
};

var useStyles$k = makeStyles(function (theme) {
  return {
    textField: {
      marginLeft: theme.spacing(1),
      marginRight: theme.spacing(1)
    },
    dense: {
      marginTop: theme.spacing(1)
    },
    input: {
      borderRadius: 2,
      height: 32,
      padding: 0,
      marginTop: 3
    },
    formTextInput: {
      fontSize: 14
    },
    labelRoot: {
      fontSize: 14
    }
  };
});
var SelectGroupMenu = function SelectGroupMenu(_ref) {
  var data = _ref.data,
      placeholder = _ref.placeholder,
      id = _ref.id,
      handleChange = _ref.handleChange;
  var classes = useStyles$k();
  var options = data && data.map(function (option) {
    var grouping = option.category;
    return _extends({
      grouping: grouping
    }, option);
  });
  return /*#__PURE__*/React.createElement(Autocomplete, {
    id: id,
    onChange: function onChange(event, value) {
      return handleChange(value);
    },
    options: options.sort(function (a, b) {
      return -b.grouping.localeCompare(a.grouping);
    }),
    groupBy: function groupBy(option) {
      return option.grouping;
    },
    getOptionLabel: function getOptionLabel(option) {
      return option.label;
    },
    style: {
      width: 300
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React.createElement(TextField, _extends({}, params, {
        label: !params.inputProps.value && placeholder,
        variant: "outlined",
        size: "small",
        InputLabelProps: {
          shrink: false,
          classes: {
            root: classes.labelRoot,
            focused: classes.labelFocused
          }
        },
        SelectProps: {
          MenuProps: {
            className: classes.menu
          }
        }
      }));
    }
  });
};

var useStyles$l = makeStyles(function (theme) {
  return {
    textField: {
      marginLeft: theme.spacing(1),
      marginRight: theme.spacing(1)
    },
    dense: {
      marginTop: theme.spacing(1)
    },
    input: {
      borderRadius: 2,
      height: 32,
      padding: 0,
      marginTop: 3
    },
    formTextInput: {
      fontSize: 14
    },
    labelRoot: {
      fontSize: 14
    }
  };
});
var FluentSelectGroupMenu = function FluentSelectGroupMenu(_ref) {
  var data = _ref.data,
      placeholder = _ref.placeholder,
      id = _ref.id,
      handleChange = _ref.handleChange;
  var classes = useStyles$l();
  var options = data && data.map(function (option) {
    var firstLetter = option.label[0].toUpperCase();
    return _extends({
      firstLetter: /[0-9]/.test(firstLetter) ? '0-9' : firstLetter
    }, option);
  });
  return /*#__PURE__*/React.createElement(Autocomplete, {
    id: id,
    onChange: function onChange(event, value) {
      return handleChange(value);
    },
    options: options.sort(function (a, b) {
      return -b.firstLetter.localeCompare(a.firstLetter);
    }),
    groupBy: function groupBy(option) {
      return option.firstLetter;
    },
    getOptionLabel: function getOptionLabel(option) {
      return option.label;
    },
    style: {
      width: 300
    },
    renderInput: function renderInput(params) {
      return /*#__PURE__*/React.createElement(TextField, _extends({}, params, {
        label: !params.inputProps.value && placeholder,
        variant: "outlined",
        size: "small",
        InputLabelProps: {
          shrink: false,
          classes: {
            root: classes.labelRoot,
            focused: classes.labelFocused
          }
        },
        SelectProps: {
          MenuProps: {
            className: classes.menu
          }
        }
      }));
    }
  });
};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning$1(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning$1(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning$1('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has$1(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning$1(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

var useTreeItemStyles = makeStyles$1(function (theme) {
  return {
    root: {
      color: theme.palette.text.secondary,
      '&:hover > $content': {
        backgroundColor: theme.palette.action.hover
      },
      '&:focus > $content, &$selected > $content': {
        backgroundColor: "var(--tree-view-bg-color, " + theme.palette.grey[300] + ")",
        color: 'var(--tree-view-color)'
      },
      '&:focus > $marker, &$selected > $marker': {
        backgroundColor: "var(--tree-view-bg-color, " + theme.palette.grey[300] + ")",
        color: 'var(--tree-view-color)'
      },
      '&:focus > $content $label, &:hover > $content $label, &$selected > $content $label': {
        backgroundColor: 'transparent'
      }
    },
    content: {
      color: theme.palette.text.secondary,
      paddingRight: theme.spacing(1),
      paddingLeft: theme.spacing(1),
      fontWeight: theme.typography.fontWeightMedium,
      '$expanded > &': {
        fontWeight: theme.typography.fontWeightRegular
      }
    },
    group: {
      marginLeft: 0,
      '& $content': {
        paddingLeft: theme.spacing(2)
      }
    },
    expanded: {},
    selected: {},
    label: {
      fontWeight: 'inherit',
      color: 'inherit'
    },
    labelRoot: {
      display: 'flex',
      alignItems: 'center',
      padding: theme.spacing(1.5, 0)
    },
    labelIcon: {
      marginRight: theme.spacing(2.5),
      fontSize: 16,
      color: theme.palette.secondary.main
    },
    labelText: {
      fontWeight: 'inherit',
      fontSize: 14,
      flexGrow: 1
    }
  };
});

var StyledTreeItem = function StyledTreeItem(props) {
  var classes = useTreeItemStyles();

  var labelText = props.labelText,
      LabelIcon = props.labelIcon,
      labelInfo = props.labelInfo,
      color = props.color,
      bgColor = props.bgColor,
      to = props.to,
      children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["labelText", "labelIcon", "labelInfo", "color", "bgColor", "to", "children"]);

  return /*#__PURE__*/React.createElement(Link, {
    to: to,
    style: {
      textDecoration: 'none'
    }
  }, /*#__PURE__*/React.createElement(TreeItem, _extends({
    label: /*#__PURE__*/React.createElement("div", {
      className: classes.labelRoot
    }, LabelIcon && /*#__PURE__*/React.createElement(LabelIcon, {
      color: "inherit",
      className: classes.labelIcon
    }), /*#__PURE__*/React.createElement(Typography$1, {
      variant: "body2",
      className: classes.labelText
    }, labelText), /*#__PURE__*/React.createElement(Typography$1, {
      variant: "caption",
      color: "inherit"
    }, labelInfo)),
    style: {
      '--tree-view-color': color,
      '--tree-view-bg-color': bgColor
    },
    classes: {
      root: classes.root,
      content: classes.content,
      expanded: classes.expanded,
      selected: classes.selected,
      group: classes.group,
      label: classes.label
    }
  }, other, {
    children: children
  })));
};

StyledTreeItem.propTypes = {
  bgColor: propTypes.string,
  color: propTypes.string,
  labelIcon: propTypes.elementType,
  labelInfo: propTypes.string,
  labelText: propTypes.string.isRequired
};
var useStyles$m = makeStyles$1({
  root: {
    height: 264,
    flexGrow: 1,
    maxWidth: 280
  }
});
var FluentSideNav = function FluentSideNav(props) {
  var classes = useStyles$m();
  var data = props.data;
  var renderedArray = data.map(function (nodes) {
    var icons = {
      ViewDashboardIcon: ViewDashboardIcon,
      AdminALogo32Icon: AdminALogo32Icon,
      MessageIcon: MessageIcon,
      ContentFeedIcon: ContentFeedIcon,
      RawSourceIcon: RawSourceIcon,
      BugIcon: BugIcon,
      OfficeFormsLogo16Icon: OfficeFormsLogo16Icon,
      CloudUploadIcon: CloudUploadIcon
    };
    return /*#__PURE__*/React.createElement(StyledTreeItem, {
      key: nodes.nodeId,
      nodeId: nodes.nodeId,
      labelText: nodes.labelText,
      labelIcon: typeof nodes.labelIcon === 'string' ? icons[nodes.labelIcon] : nodes.labelIcon,
      to: nodes.to !== '' && nodes.to,
      children: nodes.children && nodes.children.map(function (nodes) {
        return /*#__PURE__*/React.createElement(StyledTreeItem, {
          key: nodes.nodeId,
          nodeId: nodes.nodeId,
          labelText: nodes.labelText,
          labelIcon: typeof nodes.labelIcon === 'string' ? icons[nodes.labelIcon] : nodes.labelIcon,
          to: nodes.to !== '' && nodes.to
        });
      })
    });
  });
  return /*#__PURE__*/React.createElement(TreeView, {
    className: classes.root,
    defaultCollapseIcon: /*#__PURE__*/React.createElement(ChevronDownIcon, null),
    defaultExpandIcon: /*#__PURE__*/React.createElement(ChevronRightIcon, null),
    defaultEndIcon: /*#__PURE__*/React.createElement("div", {
      style: {
        width: 24
      }
    })
  }, renderedArray);
};

var useStyles$n = makeStyles(function (theme) {
  return {
    root: {
      textTransform: 'none',
      minWidth: 52,
      padding: 0,
      paddingLeft: theme.spacing(2),
      paddingRight: theme.spacing(8),
      fontWeight: theme.typography.fontWeightRegular,
      background: function background(props) {
        return props.block && lighten(theme.palette.primary.main, 0.7);
      },
      zIndex: 9,
      borderRight: function borderRight(props) {
        return props.block && '1px solid rgb(179 177 177)';
      },
      '&:hover': {
        background: function background(props) {
          return props.block && lighten(theme.palette.primary.main, 0.6);
        }
      },
      '&$selected': {},
      '&:focus': {}
    },
    wrapper: {
      flexDirection: 'row',
      zIndex: 999999
    },
    labelIcon: {
      minHeight: 45
    }
  };
});
var FluentSimpleTab = function FluentSimpleTab(props) {
  var value = props.value,
      onChange = props.onChange,
      label = props.label,
      icon = props.icon,
      className = props.className;
  var classes = useStyles$n(props);
  return /*#__PURE__*/React.createElement(Tab, {
    icon: icon && /*#__PURE__*/React.createElement("div", {
      style: {
        paddingRight: 10
      }
    }, icon),
    value: value,
    onChange: onChange,
    label: label,
    className: className,
    classes: {
      root: classes.root,
      wrapper: classes.wrapper,
      labelIcon: classes.labelIcon,
      selected: classes.selected
    }
  });
};

var useStyles$o = makeStyles(function (theme) {
  return {
    indicator: {
      backgroundColor: lighten(theme.palette.primary.main, 0.5),
      top: function top(props) {
        return props.block ? 0 : 45;
      },
      height: function height(props) {
        return props.block && 100;
      }
    }
  };
});
var FluentSimpleTabs = function FluentSimpleTabs(props) {
  var value = props.value,
      onChange = props.onChange,
      children = props.children,
      ariaLabel = props.ariaLabel;
  var classes = useStyles$o(props);
  return /*#__PURE__*/React.createElement(Tabs, {
    value: value,
    onChange: onChange,
    "aria-label": ariaLabel,
    classes: {
      indicator: classes.indicator
    }
  }, children);
};

var FluentTabPanel = function FluentTabPanel(props) {
  var children = props.children,
      value = props.value,
      index = props.index,
      other = _objectWithoutPropertiesLoose(props, ["children", "value", "index"]);

  return /*#__PURE__*/React.createElement("div", _extends({
    role: "tabpanel",
    hidden: value !== index,
    id: "simple-tabpanel-" + index,
    "aria-labelledby": "simple-tab-" + index
  }, other), value === index && /*#__PURE__*/React.createElement(Box, {
    p: 3
  }, /*#__PURE__*/React.createElement(Typography, {
    component: "div"
  }, children)));
};
FluentTabPanel.propTypes = {
  children: propTypes.node,
  index: propTypes.any.isRequired,
  value: propTypes.any.isRequired
};

function a11yProps(index) {
  return {
    id: "simple-tab-" + index,
    'aria-controls': "simple-tabpanel-" + index
  };
}

var useStyles$p = makeStyles(function (theme) {
  return {
    root: {
      flexGrow: 1,
      backgroundColor: theme.palette.background.paper
    }
  };
});
var FluentTabUtility = function FluentTabUtility(props) {
  var classes = useStyles$p();
  var TabList = props.TabList,
      block = props.block,
      className = props.className;

  var _useState = useState(0),
      value = _useState[0],
      setValue = _useState[1];

  var handleChange = function handleChange(event, newValue) {
    setValue(newValue);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, /*#__PURE__*/React.createElement(FluentSimpleTabs, {
    value: value,
    block: block,
    onChange: handleChange
  }, TabList.map(function (item, index) {
    return /*#__PURE__*/React.createElement(FluentSimpleTab, _extends({
      key: index,
      label: item.label
    }, a11yProps(index), {
      icon: item.icon,
      block: block
    }));
  })), TabList.map(function (item, index) {
    return /*#__PURE__*/React.createElement(FluentTabPanel, {
      block: block,
      value: value,
      index: index,
      key: index
    }, item.child);
  }));
};

var useStyles$q = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    prefix: {
      fontWeight: 600
    },
    title: {
      flex: 1
    },
    detail: {
      marginLeft: theme.spacing(2)
    }
  };
});

var FileProfile = function FileProfile(props) {
  var classes = useStyles$q();
  var children = props.children,
      fileName = props.fileName,
      fileType = props.fileType,
      size = props.size,
      lastModifiedDate = props.lastModifiedDate;
  return /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "body1",
    className: classes.title
  }, /*#__PURE__*/React.createElement("strong", null, fileName)), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption",
    className: classes.detail
  }, /*#__PURE__*/React.createElement("span", {
    className: classes.prefix
  }, "Type:"), " ", fileType), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption",
    className: classes.detail
  }, /*#__PURE__*/React.createElement("span", {
    className: classes.prefix
  }, "Size:"), " ", size)), children, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, /*#__PURE__*/React.createElement("span", {
    className: classes.prefix
  }, "Last Modified:"), ' ', lastModifiedDate));
};

var useStyles$r = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      justifyContent: 'center'
    },
    image: {
      maxWidth: 465
    }
  };
});

var ImagePreview = function ImagePreview(props) {
  var image = props.image;
  var classes = useStyles$r();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("img", {
    className: classes.image,
    src: image,
    alt: "upload preview"
  }));
};

var FileType = function FileType(props) {
  var type = '';
  var fileType = props.fileType,
      image = props.image,
      fileName = props.fileName,
      size = props.size,
      lastModifiedDate = props.lastModifiedDate;

  switch (fileType) {
    case 'pdf':
      type = /*#__PURE__*/React.createElement(FileProfile, {
        fileType: fileType,
        fileName: fileName,
        size: size,
        lastModifiedDate: lastModifiedDate
      });
      break;

    case 'doc':
      type = /*#__PURE__*/React.createElement(FileProfile, {
        fileType: fileType,
        fileName: fileName,
        size: size,
        lastModifiedDate: lastModifiedDate
      });
      break;

    case 'png':
      type = /*#__PURE__*/React.createElement(FileProfile, {
        fileType: fileType,
        fileName: fileName,
        size: size,
        lastModifiedDate: lastModifiedDate
      }, /*#__PURE__*/React.createElement(ImagePreview, {
        image: image
      }));
      break;

    case 'jpg':
      type = /*#__PURE__*/React.createElement(FileProfile, {
        fileType: fileType,
        fileName: fileName,
        size: size,
        lastModifiedDate: lastModifiedDate
      }, /*#__PURE__*/React.createElement(ImagePreview, {
        image: image
      }));
      break;

    case 'jpeg':
      type = /*#__PURE__*/React.createElement(FileProfile, {
        fileType: fileType,
        fileName: fileName,
        size: size,
        lastModifiedDate: lastModifiedDate
      }, /*#__PURE__*/React.createElement(ImagePreview, {
        image: image
      }));
      break;
  }

  return type;
};

var useStyles$s = makeStyles(function (theme) {
  return {
    avatarImage: {
      width: 200,
      height: 200,
      borderRadius: 100,
      border: '3px solid',
      borderColor: theme.palette.primary.main,
      marginTop: -3,
      marginLeft: -3
    },
    image: {
      width: 300,
      height: '100%',
      border: '2px solid',
      borderColor: theme.palette.primary.main,
      marginTop: -3,
      marginLeft: -3
    },
    instruction: {
      display: 'flex',
      alignContent: 'center',
      justifyContent: 'center'
    },
    icon: {
      display: 'flex',
      justifyContent: 'center'
    },
    avatarIcon: {
      display: 'flex',
      justifyContent: 'center',
      marginTop: '35%'
    },
    previewCard: {
      maxWidth: 500
    },
    action: {
      marginTop: theme.spacing(1),
      marginBottom: theme.spacing(1),
      display: 'flex',
      flexDirection: 'row'
    },
    divider: {
      marginTop: theme.spacing(1)
    },
    initialInstruction: {
      marginLeft: theme.spacing(2),
      marginTop: theme.spacing(0.5)
    }
  };
});
var FileUpload = function FileUpload(props) {
  var _useState = useState(),
      file = _useState[0],
      setFile = _useState[1];

  var _useState2 = useState(),
      previewUrl = _useState2[0],
      setPreviewUrl = _useState2[1];

  var _useState3 = useState(false),
      isValid = _useState3[0],
      setIsValid = _useState3[1];

  var _useState4 = useState(),
      fileType = _useState4[0],
      setFileType = _useState4[1];

  var _useState5 = useState(),
      fileName = _useState5[0],
      setFileName = _useState5[1];

  var _useState6 = useState(),
      fileSize = _useState6[0],
      setFileSize = _useState6[1];

  var _useState7 = useState(),
      fileDate = _useState7[0],
      setFileDate = _useState7[1];

  var id = props.id,
      onInput = props.onInput,
      accept = props.accept,
      errorText = props.errorText;
  var classes = useStyles$s();
  var filePickerRef = useRef();
  useEffect(function () {
    if (!file) {
      return;
    }

    var fileReader = new window.FileReader();

    fileReader.onload = function () {
      setPreviewUrl(fileReader.result);
    };

    fileReader.readAsDataURL(file);
  }, [file]);

  var pickedHandler = function pickedHandler(event) {
    var pickedFile = event.target.files[0];
    var fileIsValid = isValid;
    setFileName(event.target.files[0].name);
    setFileSize(event.target.files[0].size);
    setFileDate(event.target.files[0].lastModifiedDate.toString());
    var str = event.target.files[0].name.split('.')[1];
    setFileType(str);

    if (event.target.files && event.target.files.length === 1) {
      var _pickedFile = event.target.files[0];
      setFile(_pickedFile);
      setIsValid(true);
    } else {
      setIsValid(false);
      fileIsValid = false;
    }

    onInput(id, pickedFile, fileIsValid);
  };

  var pickFileHandler = function pickFileHandler() {
    filePickerRef.current.click();

    if (file && file !== previewUrl) {
      reset();
    }
  };

  var formatBytes = function formatBytes(bytes, decimals) {
    if (decimals === void 0) {
      decimals = 2;
    }

    if (bytes === 0) return '0 Bytes';
    var k = 1024;
    var dm = decimals < 0 ? 0 : decimals;
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    var i = Math.floor(Math.log(bytes) / Math.log(k));
    return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
  };

  var reset = function reset() {
    var fileReader = new window.FileReader();

    fileReader.onload = function () {
      setPreviewUrl(fileReader.result);
    };

    fileReader.readAsDataURL(file);
  };

  return /*#__PURE__*/React.createElement(Card, {
    className: classes.previewCard,
    variant: "outlined"
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("div", {
    className: classes.formControl
  }, /*#__PURE__*/React.createElement("input", {
    id: id,
    ref: filePickerRef,
    style: {
      display: 'none'
    },
    type: "file",
    accept: accept,
    onChange: pickedHandler
  }), /*#__PURE__*/React.createElement("div", {
    className: classes.imageUpload
  }, !previewUrl && /*#__PURE__*/React.createElement("div", {
    className: classes.action
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.action
  }, /*#__PURE__*/React.createElement(FluentButton$1, {
    type: "button",
    variant: "contained",
    color: "secondary",
    onClick: pickFileHandler
  }, "Select File"), /*#__PURE__*/React.createElement("div", {
    className: classes.initialInstruction
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, "Click 'Select File' to upload a file from your computer")))), previewUrl && /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement("div", {
    className: classes.imagePreview
  }, /*#__PURE__*/React.createElement(FileType, {
    fileType: fileType,
    image: previewUrl,
    fileName: fileName,
    size: formatBytes(fileSize),
    lastModifiedDate: fileDate
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, null)))), !isValid && /*#__PURE__*/React.createElement(Typography, null, errorText, " "))));
};

var MapContext = new createContext();

var useStyles$t = makeStyles(function (theme) {
  return {
    root: {
      minWidth: 600,
      height: '85vh'
    }
  };
});

var Map = function Map(_ref) {
  var children = _ref.children,
      zoom = _ref.zoom,
      center = _ref.center,
      projection = _ref.projection;
  var classes = useStyles$t();
  var mapRef = useRef();

  var _useState = useState(null),
      map = _useState[0],
      setMap = _useState[1];

  useEffect(function () {
    var options = {
      view: new View({
        zoom: zoom,
        center: center,
        projection: projection
      }),
      interactions: defaults().extend([new DragRotateAndZoom()]),
      layers: [],
      controls: [],
      overlays: []
    };
    var mapObject = new Map$2(options);
    mapObject.setTarget(mapRef.current);
    setMap(mapObject);
    return function () {
      return mapObject.setTarget(undefined);
    };
  }, []);
  useEffect(function () {
    if (!map) return;
    map.getView().setZoom(zoom);
  }, [zoom]);
  useEffect(function () {
    if (!map) return;
    map.getView().setCenter(center);
  }, [center]);
  useEffect(function () {
    if (!map) return;
    map.getview().getprojection(projection);
  }, [projection]);
  return /*#__PURE__*/React.createElement(MapContext.Provider, {
    value: {
      map: map
    }
  }, /*#__PURE__*/React.createElement("div", {
    ref: mapRef,
    className: classes.root
  }, children));
};

var Layers = function Layers(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", null, children);
};

var TileLayer = function TileLayer(_ref) {
  var source = _ref.source,
      _ref$zIndex = _ref.zIndex,
      zIndex = _ref$zIndex === void 0 ? 0 : _ref$zIndex;

  var _useContext = useContext(MapContext),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var tileLayer = new OLTileLayer({
      source: source,
      zIndex: zIndex
    });
    map.addLayer(tileLayer);
    tileLayer.setZIndex(zIndex);
    return function () {
      if (map) {
        map.removeLayer(tileLayer);
      }
    };
  }, [map, source]);
  return null;
};

function osm() {
  return new OSM();
}

var Controls = function Controls(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", null, children);
};

var FullScreenControl = function FullScreenControl() {
  var _useContext = useContext(MapContext),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var fullScreenControl = new FullScreen({});
    map.controls.push(fullScreenControl);
    return function () {
      return map.controls.remove(fullScreenControl);
    };
  }, [map]);
  return null;
};

var useStyles$u = makeStyles(function (theme) {
  return {
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});

var LocationPin = function LocationPin(props) {
  var getLocation = props.getLocation,
      location = props.location,
      tooltip = props.tooltip;
  var classes = useStyles$u();
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement(Tooltip, {
    arrow: true,
    title: tooltip
  }, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: function onClick() {
      return getLocation(location);
    },
    color: "primary",
    icon: MapPinIcon
  })));
};

var useStyles$v = makeStyles$1({
  root: {
    width: 250
  },
  input: {
    width: 42
  }
});

var FluentInputSlider = function FluentInputSlider(props) {
  var value = props.value,
      handleSliderChange = props.handleSliderChange,
      handleInputChange = props.handleInputChange,
      handleBlur = props.handleBlur;
  var classes = useStyles$v();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 2,
    alignItems: "center"
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true
  }, /*#__PURE__*/React.createElement(ZoomIcon, null)), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: true
  }, /*#__PURE__*/React.createElement(Slider, {
    value: typeof value === 'number' ? value : 0,
    onChange: handleSliderChange,
    "aria-labelledby": "input-slider",
    step: 1,
    marks: true,
    min: 0,
    max: 20
  })), /*#__PURE__*/React.createElement(Grid, {
    item: true
  }, /*#__PURE__*/React.createElement(Input, {
    className: classes.input,
    value: value,
    margin: "dense",
    onChange: handleInputChange,
    onBlur: handleBlur,
    inputProps: {
      step: 1,
      min: 0,
      max: 20,
      type: 'number',
      'aria-labelledby': 'input-slider'
    }
  }))));
};

var useStyles$w = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});

var ControlZoom = function ControlZoom(props) {
  var zoomIn = props.zoomIn,
      zoomOut = props.zoomOut,
      value = props.value,
      handleSliderChange = props.handleSliderChange,
      handleInputChange = props.handleInputChange,
      handleBlur = props.handleBlur,
      reset = props.reset;
  var classes = useStyles$w();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: zoomIn,
    color: "primary",
    icon: ZoomInIcon
  }), /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: zoomOut,
    color: "primary",
    icon: ZoomOutIcon
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentInputSlider, {
    value: value,
    handleSliderChange: handleSliderChange,
    handleInputChange: handleInputChange,
    handleBlur: handleBlur
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: reset,
    color: "primary",
    icon: ZoomToFitIcon
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })));
};

var useStyles$x = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    lat: {
      marginRight: theme.spacing(2)
    }
  };
});

var Position = function Position(props) {
  var classes = useStyles$x();
  var changeLat = props.changeLat,
      changeLong = props.changeLong,
      value = props.value,
      setPosition = props.setPosition;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.lat
  }, /*#__PURE__*/React.createElement(FormControl, {
    className: clsx(classes.margin, classes.withoutLabel, classes.textField)
  }, /*#__PURE__*/React.createElement(Input$1, {
    id: "longitude",
    value: value,
    onChange: changeLong,
    endAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
      position: "end"
    }, "Long"),
    "aria-describedby": "longitude-input",
    inputProps: {
      'aria-label': 'longitude-input'
    }
  }))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FormControl, {
    className: clsx(classes.margin, classes.withoutLabel, classes.textField)
  }, /*#__PURE__*/React.createElement(Input$1, {
    id: "latitude",
    value: value,
    onChange: changeLat,
    endAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
      position: "end"
    }, "Lat"),
    "aria-describedby": "latitude-input",
    inputProps: {
      'aria-label': 'latitude-input'
    }
  }))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: setPosition,
    color: "primary",
    icon: POIIcon
  })));
};

var useStyles$y = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    filter: {
      display: 'flex',
      flex: 1
    },
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});

var MapControlsStandard = function MapControlsStandard(props) {
  var classes = useStyles$y();
  var value = props.value,
      setZoom = props.setZoom,
      handleSliderChange = props.handleSliderChange,
      handleInputChange = props.handleInputChange,
      handleBlur = props.handleBlur,
      zoomIn = props.zoomIn,
      zoomOut = props.zoomOut,
      reset = props.reset,
      changeLat = props.changeLat,
      changeLong = props.changeLong,
      setPosition = props.setPosition,
      getLocation = props.getLocation,
      locations = props.locations;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.filter
  }, locations && locations.map(function (item, index) {
    return /*#__PURE__*/React.createElement(LocationPin, {
      key: index,
      location: item.location,
      getLocation: getLocation,
      tooltip: item.tooltip
    });
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement(Position, {
    changeLat: changeLat,
    changeLong: changeLong,
    setPosition: setPosition
  }), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ControlZoom, {
    zoomIn: zoomIn,
    zoomOut: zoomOut,
    value: value,
    setValue: setZoom,
    handleSliderChange: handleSliderChange,
    handleInputChange: handleInputChange,
    handleBlur: handleBlur,
    reset: reset
  })));
};

var GeoMap = function GeoMap(props) {
  var locations = props.locations,
      start = props.start,
      mapType = props.mapType,
      tooltip = props.tooltip,
      bingKey = props.bingKey,
      toolbar = props.toolbar,
      width = props.width,
      height = props.height,
      defaultZoom = props.defaultZoom;

  var _useState = useState(start),
      center = _useState[0],
      setCenter = _useState[1];

  var _useState2 = useState(defaultZoom),
      zoom = _useState2[0],
      setZoom = _useState2[1];

  var _useState3 = useState(true),
      showLayer1 = _useState3[0],
      setShowLayer1 = _useState3[1];

  var _useState4 = useState(true),
      showLayer2 = _useState4[0],
      setShowLayer2 = _useState4[1];

  var _useState5 = useState(),
      lat = _useState5[0],
      setLat = _useState5[1];

  var _useState6 = useState(),
      _long = _useState6[0],
      setLong = _useState6[1];

  var _useState7 = useState(mapType),
      displayType = _useState7[0],
      setDisplayType = _useState7[1];

  var resetPosition = function resetPosition() {
    setCenter(start);
    setZoom(9);
  };

  var sendPosition = function sendPosition(position) {
    setCenter(position);
    console.log('POSITION', position);
  };

  var controlZoom = function controlZoom(input) {
    var direction = input === 'in' ? 1 : -1;
    setZoom(zoom + direction);
  };

  var handleSliderChange = function handleSliderChange(event, newValue) {
    setZoom(newValue);
  };

  var handleInputChange = function handleInputChange(event) {
    setZoom(event.target.value === '' ? '' : Number(event.target.value));
  };

  var handleBlur = function handleBlur() {
    if (zoom < 0) {
      setZoom(0);
    } else if (zoom > 100) {
      setZoom(100);
    }
  };

  var handleInputPositionLat = function handleInputPositionLat(event) {
    setLat(event.target.value);
  };

  var handleInputPositionLong = function handleInputPositionLong(event) {
    setLong(event.target.value);
  };

  var setNewPosition = function setNewPosition() {
    setCenter([lat, _long]);
  };

  var handleViewType = useCallback(function (event, newType) {
    setDisplayType(newType);
  }, []);

  var getLocationValue = function getLocationValue(value) {
    setCenter(value.location);
  };

  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: width,
      height: height,
      overflow: 'hidden'
    }
  }, toolbar && /*#__PURE__*/React.createElement(Toolbar, null, /*#__PURE__*/React.createElement(MapControlsStandard, {
    showLayer1: showLayer1,
    showLayer2: showLayer2,
    setShowLayer1: setShowLayer1,
    setShowLayer2: setShowLayer2,
    zoomIn: function zoomIn() {
      return controlZoom('in');
    },
    zoomOut: function zoomOut() {
      return controlZoom('out');
    },
    value: zoom,
    setValue: setZoom,
    handleSliderChange: handleSliderChange,
    handleInputChange: handleInputChange,
    handleBlur: handleBlur,
    reset: resetPosition,
    changeLat: handleInputPositionLat,
    changeLong: handleInputPositionLong,
    setPosition: setNewPosition,
    handleChange: handleViewType,
    displayType: displayType,
    getLocation: sendPosition,
    locations: locations,
    tooltip: tooltip,
    getLocationValue: getLocationValue
  })), /*#__PURE__*/React.createElement(Map, {
    center: fromLonLat(center),
    zoom: zoom
  }, /*#__PURE__*/React.createElement(Layers, null, /*#__PURE__*/React.createElement(TileLayer, {
    source: osm(),
    zIndex: 0
  }), /*#__PURE__*/React.createElement(TileLayer, {
    source: new BingMaps({
      preload: Infinity,
      visible: true,
      imagerySet: displayType,
      key: bingKey
    }),
    zIndex: 0
  })), /*#__PURE__*/React.createElement(Controls, null, /*#__PURE__*/React.createElement(FullScreenControl, null))));
};

var MapContext$1 = new createContext();

var VectorLayer = function VectorLayer(_ref) {
  var source = _ref.source,
      style = _ref.style,
      _ref$zIndex = _ref.zIndex,
      zIndex = _ref$zIndex === void 0 ? 0 : _ref$zIndex;

  var _useContext = useContext(MapContext$1),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var vectorLayer = new OLVectorLayer({
      source: source,
      style: style
    });
    map.addLayer(vectorLayer);
    vectorLayer.setZIndex(zIndex);
    return function () {
      if (map) {
        map.removeLayer(vectorLayer);
      }
    };
  }, [map, source]);
  return null;
};

var TileLayer$1 = function TileLayer(_ref) {
  var source = _ref.source,
      _ref$zIndex = _ref.zIndex,
      zIndex = _ref$zIndex === void 0 ? 0 : _ref$zIndex;

  var _useContext = useContext(MapContext$1),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var tileLayer = new OLTileLayer({
      source: source,
      zIndex: zIndex
    });
    map.addLayer(tileLayer);
    tileLayer.setZIndex(zIndex);
    return function () {
      if (map) {
        map.removeLayer(tileLayer);
      }
    };
  }, [map, source]);
  return null;
};

var ImageLayer = function ImageLayer(_ref) {
  var source = _ref.source,
      _ref$zIndex = _ref.zIndex,
      zIndex = _ref$zIndex === void 0 ? 0 : _ref$zIndex;

  var _useContext = useContext(MapContext$1),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var imageLayer = new OLImageLayer({
      source: source,
      zIndex: zIndex
    });
    map.addLayer(imageLayer);
    imageLayer.setZIndex(zIndex);
    return function () {
      if (map) {
        map.removeLayer(imageLayer);
      }
    };
  }, [map, source]);
  return null;
};

var Layers$1 = function Layers(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", null, children);
};

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var FreeFormField = function FreeFormField(props) {
  var _useState = useState(''),
      text = _useState[0],
      setText = _useState[1];

  return /*#__PURE__*/React.createElement(FluentTextField$1, {
    variant: "outlined",
    size: "small",
    name: "map search",
    "aria-describedby": "search-by-address",
    value: text,
    fullWidth: true,
    InputProps: {
      startAdornment: /*#__PURE__*/React.createElement(InputAdornment, {
        position: "start"
      }, /*#__PURE__*/React.createElement(SearchIcon, null))
    },
    onChange: function onChange(event) {
      setText(event.target.value);
      props.didUpdateText(event.target.value);
    }
  });
};

var useStyles$z = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    button: {
      marginTop: theme.spacing(1)
    }
  };
});

var GeoLocation = function GeoLocation(props) {
  var getPoints = function getPoints(address) {
    try {
      var url = "http://dev.virtualearth.net/REST/v1/Locations/US/" + house + "%20" + address1 + ",%20" + city + ",%20" + state + "?o=json&key=AuLp5uwpaqURqvvQt3hd8V5YDYx2yCWSUZuuHHhgwR5PYW8vlOT7Zh__eC-Su9rA";
      return Promise.resolve(_catch(function () {
        return Promise.resolve(fetch(url, {})).then(function (response) {
          if (!response.ok) {
            throw new Error(response.statusText);
          }

          return Promise.resolve(response.json()).then(function (json) {
            console.log('BING RESPONSE: ', json.resourceSets[0].resources[0].geocodePoints[0].coordinates);
            setCoordinates(json.resourceSets[0].resources[0].geocodePoints[0].coordinates);
            sendSelected(fromLonLat(json.resourceSets[0].resources[0].geocodePoints[0].coordinates.reverse()));
          });
        });
      }, function (err) {
        console.log("Node: " + err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var geocode = function geocode(address) {
    try {
      var formattedAddress = address.split(' ').join('+');
      formattedAddress = formattedAddress.split('\n').join('+');
      console.log('FORMATTED ADDRESS', formattedAddress);
      var url = "https://geocoder.say.rocks/?address=" + formattedAddress + "&debug=" + debug;
      return Promise.resolve(_catch(function () {
        return Promise.resolve(fetch(url, {})).then(function (response) {
          if (!response.ok) {
            throw new Error(response.statusText);
          }

          return Promise.resolve(response.json()).then(function (json) {
            var house_number = json.house_number,
                country = json.country,
                house = json.house,
                road = json.road,
                city = json.city,
                state = json.state,
                unit = json.unit,
                postcode = json.postcode;
            setAddress1(house_number + " " + road);
            setAddress2("" + unit);
            setHouse(house);
            setCity(city);
            setState(state);
            setZip(postcode);
            setCountry(country);
            setResponse(JSON.stringify(json, null, 2));
          });
        });
      }, function (err) {
        console.log("Node: " + err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var _useState = useState(''),
      city = _useState[0],
      setCity = _useState[1];

  var _useState2 = useState(''),
      state = _useState2[0],
      setState = _useState2[1];

  var _useState3 = useState(''),
      setZip = _useState3[1];

  var _useState4 = useState(''),
      setCountry = _useState4[1];

  var _useState5 = useState(''),
      house = _useState5[0],
      setHouse = _useState5[1];

  var _useState6 = useState(''),
      address1 = _useState6[0],
      setAddress1 = _useState6[1];

  var _useState7 = useState(''),
      setAddress2 = _useState7[1];

  var _useState8 = useState('{}'),
      setResponse = _useState8[1];

  var _useState9 = useState([-117.29982, 33.054275]),
      setCoordinates = _useState9[1];

  var sendSelected = props.sendSelected,
      center = props.center;
  var debug = true;
  useEffect(function () {
    var listener = function listener(event) {
      if (event.code === 'Enter' || event.code === 'NumpadEnter') {
        console.log('Enter key was pressed.', event);
        getPoints();
      }
    };

    document.addEventListener('keydown', listener);
    return function () {
      document.removeEventListener('keydown', listener);
    };
  }, [center]);
  var classes = useStyles$z();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(FreeFormField, {
    didUpdateText: function didUpdateText(text) {
      if (text.length) {
        geocode(text);
      } else {
        setAddress1('');
        setAddress2('');
        setCity('');
        setState('');
        setZip('');
        setCountry('');
        setResponse('{}');
      }
    }
  }), /*#__PURE__*/React.createElement(FluentButton$1, {
    className: classes.button,
    size: "small",
    onClick: getPoints
  }, "Go"));
};

var usePrevious = function usePrevious(value) {
  var ref = useRef();
  useEffect(function () {
    ref.current = value;
  }, [value]);
  return ref.current;
};

var Map$1 = function Map(_ref) {
  var children = _ref.children,
      zoom = _ref.zoom,
      center = _ref.center,
      projection = _ref.projection,
      sendSelected = _ref.sendSelected,
      sendType = _ref.sendType,
      SelectedPin = _ref.SelectedPin,
      changeLat = _ref.changeLat,
      changeLong = _ref.changeLong,
      setPosition = _ref.setPosition,
      width = _ref.width,
      height = _ref.height,
      addressBar = _ref.addressBar;
  var mapRef = useRef();

  var _useState = useState(null),
      map = _useState[0],
      setMap = _useState[1];

  var _useState2 = useState(),
      selected = _useState2[0],
      setSelected = _useState2[1];

  var _useState3 = useState(),
      markingType = _useState3[0],
      setMarkingType = _useState3[1];

  var _useState4 = useState(0),
      count = _useState4[0],
      setCount = _useState4[1];

  var _useState5 = useState(false),
      mapClicked = _useState5[0],
      setMapclicked = _useState5[1];

  var prevCount = usePrevious(count);
  useEffect(function () {
    var options = {
      view: new View({
        center: fromLonLat(center),
        zoom: zoom,
        projection: projection
      }),
      interactions: defaults().extend([new DragRotateAndZoom()]),
      layers: [],
      controls: [],
      overlays: []
    };
    var mapObject = new Map$2(options);
    mapObject.setTarget(mapRef.current);
    setMap(mapObject);
    var pointSelect = new Select({
      condition: function condition(e) {
        return click(e);
      },
      filter: function filter(f) {
        if (f.getGeometry().getType() === 'Point') {
          return true;
        }
      },
      multi: true,
      hitTolerance: 10,
      style: new Style({
        image: new Icon({
          anchor: [0.5, 48],
          anchorXUnits: 'fraction',
          anchorYUnits: 'pixels',
          src: SelectedPin
        })
      })
    });
    mapObject.addInteraction(pointSelect);
    mapObject.on('click', function (e) {
      mapObject.forEachFeatureAtPixel(e.pixel, function (a) {
        return console.log('A: ', a.id_);
      });
    });
    return function () {
      return mapObject.setTarget(undefined);
    };
  }, []);
  useEffect(function () {
    sendSelected(selected);
  }, [sendSelected, selected]);
  useEffect(function () {
    sendType(markingType);
  }, [sendType, markingType]);

  var postSelected = function postSelected(id, type) {
    setSelected(id);
    setMarkingType(type);
  };

  useEffect(function () {
    if (!map) return;
    map.getView().setZoom(zoom);
    console.log('run zoom');
  }, [zoom]);
  useEffect(function () {
    if (!map) return;
    map.on('click', function (e) {
      setMapclicked(true);
      map.forEachFeatureAtPixel(e.pixel, function (a) {
        return postSelected(a.values_.geometry.flatCoordinates[2], a.values_.geometry.flatCoordinates[3]);
      });
    });
  }, [map]);
  useEffect(function () {
    if (!map) return;
    console.log('Run useEffect center', center, zoom);
    console.log('PREV', prevCount);
    setCount(zoom);

    if (zoom === prevCount && !mapClicked) {
      map.getView().setCenter(center);
    }
  }, [center]);
  useEffect(function () {
    if (!map) return;

    if (!mapClicked) {
      map.getView().setCenter(center);
    }
  }, [map]);
  useEffect(function () {
    if (!map) return;
    map.getview().getprojection(projection);
  }, [projection]);
  return /*#__PURE__*/React.createElement(MapContext$1.Provider, {
    value: {
      map: map
    }
  }, addressBar && /*#__PURE__*/React.createElement("div", {
    style: {
      marginLeft: 35,
      marginTop: -6
    }
  }, /*#__PURE__*/React.createElement(GeoLocation, {
    center: center,
    changeLat: changeLat,
    changeLong: changeLong,
    setPosition: setPosition
  })), /*#__PURE__*/React.createElement("div", {
    ref: mapRef,
    style: {
      height: height || '85vh',
      width: width
    }
  }, children));
};

var useStyles$A = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});

var ControlZoom$1 = function ControlZoom(props) {
  var zoomIn = props.zoomIn,
      zoomOut = props.zoomOut,
      value = props.value,
      handleSliderChange = props.handleSliderChange,
      handleInputChange = props.handleInputChange,
      handleBlur = props.handleBlur,
      reset = props.reset;
  var classes = useStyles$A();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: zoomIn,
    color: "primary",
    icon: ZoomInIcon
  }), /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: zoomOut,
    color: "primary",
    icon: ZoomOutIcon
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentInputSlider, {
    value: value,
    handleSliderChange: handleSliderChange,
    handleInputChange: handleInputChange,
    handleBlur: handleBlur,
    input: true,
    icon: ZoomIcon
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    onClick: reset,
    color: "primary",
    icon: ZoomToFitIcon
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })));
};

var useStyles$B = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});

var FilterOptions = function FilterOptions(props) {
  var classes = useStyles$B();
  var showAlert = props.showAlert,
      showHome = props.showHome,
      showMarker = props.showMarker,
      toggleDisplayMarkers = props.toggleDisplayMarkers;
  var theme = useTheme();
  var inactive = lighten(theme.palette.common.black, 0.8);
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(FluentIconButton, {
    color: "primary",
    icon: AlertSolidIcon,
    onClick: function onClick() {
      return toggleDisplayMarkers('alert');
    },
    style: {
      color: showAlert ? theme.palette.error.main : inactive
    }
  }), /*#__PURE__*/React.createElement(FluentIconButton, {
    color: "primary",
    icon: HomeIcon,
    onClick: function onClick() {
      return toggleDisplayMarkers('home');
    },
    style: {
      color: showHome ? theme.palette.success.main : inactive
    }
  }), /*#__PURE__*/React.createElement(FluentIconButton, {
    color: "primary",
    icon: BoxMultiplySolidIcon,
    onClick: function onClick() {
      return toggleDisplayMarkers('mark');
    },
    style: {
      color: showMarker ? theme.palette.success.main : inactive
    }
  }));
};

var useStyles$C = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    filter: {
      display: 'flex',
      flex: 1
    },
    divider: {
      marginRight: theme.spacing(2),
      marginLeft: theme.spacing(2)
    }
  };
});
var MapFilterBar = function MapFilterBar(props) {
  var classes = useStyles$C();
  var showAlert = props.showAlert,
      toggleDisplayMarkers = props.toggleDisplayMarkers,
      value = props.value,
      setZoom = props.setZoom,
      handleSliderChange = props.handleSliderChange,
      handleInputChange = props.handleInputChange,
      handleBlur = props.handleBlur,
      zoomIn = props.zoomIn,
      zoomOut = props.zoomOut,
      reset = props.reset,
      showHome = props.showHome;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.filter
  }, /*#__PURE__*/React.createElement(FilterOptions, {
    showAlert: showAlert,
    showHome: showHome,
    toggleDisplayMarkers: toggleDisplayMarkers
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "vertical"
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ControlZoom$1, {
    zoomIn: zoomIn,
    zoomOut: zoomOut,
    value: value,
    setValue: setZoom,
    handleSliderChange: handleSliderChange,
    handleInputChange: handleInputChange,
    handleBlur: handleBlur,
    reset: reset
  })));
};

var useStyles$D = makeStyles(function (theme) {
  return {
    root: {
      position: 'absolute',
      zIndex: 9999,
      top: 50,
      right: 0
    },
    mapPage: {
      overflow: 'hidden'
    },
    collapsed: {
      width: 0,
      transition: theme.transitions.create('width', {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.leavingScreen
      })
    },
    expanded: {
      width: 300,
      transition: theme.transitions.create('width', {
        easing: theme.transitions.easing.easeIn,
        duration: theme.transitions.duration.enteringScreen
      })
    },
    wrapper: {
      padding: theme.spacing(2)
    },
    sheetWrapper: {
      display: 'flex',
      flexDirection: 'row'
    },
    toggle: {
      padding: theme.spacing(1),
      background: theme.palette.common.white,
      height: theme.spacing(6)
    }
  };
});
var MapSheet = function MapSheet(props) {
  var classes = useStyles$D();
  var children = props.children,
      collapsed = props.collapsed,
      toggle = props.toggle;
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, collapsed ? classes.collapsed : classes.expanded)
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.sheetWrapper
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.toggle
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    className: classes.extendedButton,
    onClick: toggle,
    color: "primary",
    icon: collapsed ? ChevronLeftIcon : ChevronRightIcon
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Paper, {
    square: true
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.wrapper
  }, children)))));
};

var useStyles$E = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    title: {
      fontWeight: 700
    },
    titleWrapper: {
      marginBottom: theme.spacing(1)
    },
    divider: {},
    body: {
      color: lighten(theme.palette.common.black, 0.5)
    },
    actions: {
      marginTop: theme.spacing(1),
      display: 'flex',
      flexDirection: 'row'
    },
    qty: {
      marginLeft: theme.spacing(1)
    }
  };
});
var TileDisplay = function TileDisplay(props) {
  var title = props.title,
      body = props.body,
      selected = props.selected;
  var classes = useStyles$E();
  var qty = Math.floor(Math.random() * 10) + 1;
  var theme = useTheme();

  var Indicator = function Indicator() {
    return /*#__PURE__*/React.createElement("svg", {
      width: "15",
      height: "10"
    }, /*#__PURE__*/React.createElement("circle", {
      cx: "70%",
      cy: "50%",
      r: "4",
      fill: theme.palette.success.main
    }));
  };

  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Card, {
    square: true,
    elevation: 0,
    className: classes.root,
    style: {
      background: selected && lighten(theme.palette.secondary.main, 0.9)
    }
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    className: classes.titleWrapper
  }, /*#__PURE__*/React.createElement(Typography, {
    className: classes.title,
    variant: "subtitle"
  }, title)), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Typography, {
    className: classes.body,
    variant: "caption"
  }, body))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton, {
    color: "primary",
    icon: MapPinIcon
  }))), /*#__PURE__*/React.createElement("div", {
    className: classes.actions
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Chip, {
    variant: "outlined",
    size: "small",
    label: "Active",
    icon: /*#__PURE__*/React.createElement(Indicator, null)
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.qty
  }, /*#__PURE__*/React.createElement(Chip, {
    variant: "outlined",
    size: "small",
    label: "Qty:" + qty
  }))))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Divider, null)));
};

var Controls$1 = function Controls(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement("div", null, children);
};

var FullScreenControl$1 = function FullScreenControl() {
  var _useContext = useContext(MapContext$1),
      map = _useContext.map;

  useEffect(function () {
    if (!map) return;
    var fullScreenControl = new FullScreen({});
    map.controls.push(fullScreenControl);
    return function () {
      return map.controls.remove(fullScreenControl);
    };
  }, [map]);
  return null;
};

var useControlZoom = function useControlZoom(initial) {
  var _useState = useState(initial),
      zoom = _useState[0],
      setZoom = _useState[1];

  var handleSetZoom = function handleSetZoom(input) {
    var direction = input === 'in' ? 1 : -1;
    setZoom(zoom + direction);
  };

  var handleSliderChange = function handleSliderChange(event, newValue) {
    setZoom(newValue);
  };

  var handleInputChange = function handleInputChange(event) {
    setZoom(event.target.value === '' ? '' : Number(event.target.value));
  };

  return [zoom, handleSetZoom, handleSliderChange, handleInputChange];
};
var usePosition = function usePosition(initial) {
  var _useState2 = useState(initial),
      center = _useState2[0],
      setCenter = _useState2[1];

  var handlePosition = function handlePosition(input) {
    setCenter(input);
  };

  return [center, handlePosition];
};

var ListItemLinkComponent = forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(NavLink, _extends({
    exact: true
  }, props, {
    innerRef: ref
  }));
});
ListItemLinkComponent.displayName = 'ListItemLinkComponent';
var AppMenuItemComponent = function AppMenuItemComponent(props) {
  var link = props.link,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["link", "params", "isChild"]);

  if (!link || typeof link !== 'string') {
    return /*#__PURE__*/React.createElement(ListItem, _extends({
      button: true
    }, other));
  }

  return /*#__PURE__*/React.createElement(ListItem, _extends({
    button: true,
    component: ListItemLinkComponent,
    to: {
      pathname: link,
      state: params
    }
  }, other, {
    onClick: undefined
  }));
};

var redirectToLinkOnClick = function redirectToLinkOnClick(redirectInfo) {
  var ulrEndpoint = "" + redirectInfo;
  var unityToken = sessionStorage.getItem("msal." + process.env.REACT_APP_MSAL_CLIENT_ID + ".idtoken");
  window.open(ulrEndpoint, '_blank');
};

var AppMenuItemPropTypes = {
  id: propTypes.string,
  label: propTypes.string.isRequired,
  link: propTypes.string,
  icon: propTypes.elementType,
  iconName: propTypes.string,
  items: propTypes.array,
  indent: propTypes.string,
  redirectInfo: propTypes.string,
  params: propTypes.object,
  menuItemId: propTypes.string,
  menuStructureId: propTypes.number,
  parentId: propTypes.number,
  productId: propTypes.number,
  isActive: propTypes.bool,
  roleIds: propTypes.array,
  childrenIcons: propTypes.bool,
  isChild: propTypes.bool,
  childIndex: propTypes.number
};
var useStyles$F = makeStyles(function (theme) {
  return createStyles({
    menuItem: {
      '&.active': {
        background: 'rgba(0, 0, 0, 0.08)',
        '& .MuiListItemIcon-root': {
          marginLeft: theme.spacing(2)
        }
      }
    },
    menuItemIcon: {
      minWidth: theme.spacing(5)
    },
    indent: {},
    icon: {
      width: theme.spacing(3),
      height: theme.spacing(3),
      color: theme.palette.secondary.main
    },
    expand: {
      marginRight: theme.spacing(1)
    },
    list: {
      '& .MuiListItemText-root': {
        paddingLeft: function paddingLeft(props) {
          return "calc(16px + " + 16 * (props.childIndex !== undefined ? props.childIndex : 0) + "px)";
        }
      }
    }
  });
});
var AppMenuItem = function AppMenuItem(props) {
  var _props$childrenIcons = props.childrenIcons,
      childrenIcons = _props$childrenIcons === void 0 ? true : _props$childrenIcons,
      _props$isChild = props.isChild,
      isChild = _props$isChild === void 0 ? false : _props$isChild,
      label = props.label,
      link = props.link,
      icon = props.icon,
      indent = props.indent,
      _props$items = props.items,
      items = _props$items === void 0 ? [] : _props$items,
      redirectInfo = props.redirectInfo,
      other = _objectWithoutPropertiesLoose(props, ["childrenIcons", "isChild", "childIndex", "label", "link", "icon", "indent", "items", "redirectInfo"]);

  var classes = useStyles$F(props);
  var isExpandable = (items === null || items === void 0 ? void 0 : items.length) > 0;

  var _useState = useState(false),
      open = _useState[0],
      setOpen = _useState[1];

  function handleClick() {
    if (redirectInfo) {
      redirectToLinkOnClick(redirectInfo);
    }

    setOpen(!open);
  }

  var MenuItemRoot = /*#__PURE__*/React.createElement(AppMenuItemComponent, {
    className: indent ? classes.menuItem : classes.indent,
    link: link,
    onClick: handleClick,
    "aria-expanded": isExpandable ? open : null,
    params: other,
    isChild: isChild
  }, !!icon && (isChild && childrenIcons || !isChild) && /*#__PURE__*/React.createElement(ListItemIcon, {
    className: classes.menuItemIcon
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.icon
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: icon
  }))), /*#__PURE__*/React.createElement(ListItemText, {
    primary: label,
    inset: !icon
  }), isExpandable && (open ? /*#__PURE__*/React.createElement("div", {
    className: classes.expand
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: ChevronUpIcon
  })) : /*#__PURE__*/React.createElement("div", {
    className: classes.expand
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: ChevronDownIcon
  }))));
  var MenuItemChildren = isExpandable ? /*#__PURE__*/React.createElement(Collapse, {
    "in": open,
    timeout: "auto",
    unmountOnExit: true
  }, /*#__PURE__*/React.createElement(List, {
    className: classes.list
  }, items.map(function (item, index) {
    return /*#__PURE__*/React.createElement(AppMenuItem, _extends({}, item, {
      childrenIcons: childrenIcons,
      isChild: true,
      key: index,
      childIndex: index
    }));
  }))) : null;
  return /*#__PURE__*/React.createElement("li", null, MenuItemRoot, MenuItemChildren);
};

var AppMenu = function AppMenu(_ref) {
  var childrenIcons = _ref.childrenIcons,
      menuItems = _ref.menuItems;
  return /*#__PURE__*/React.createElement("nav", {
    "aria-label": "Site Navigation"
  }, /*#__PURE__*/React.createElement(List, null, menuItems.map(function (item, index) {
    return /*#__PURE__*/React.createElement(AppMenuItem, _extends({
      key: index,
      childrenIcons: childrenIcons
    }, item));
  })));
};

var getMenuItemsRecursively = function getMenuItemsRecursively(menuItems, activeOnly, roleIds) {
  return menuItems.reduce(function (formattedItems, item) {
    try {
      if (activeOnly && !item.menuItemInstance.isActive) {
        return formattedItems;
      }

      var parameters = JSON.parse(item.menuItemInstance.parameters);

      var FluentIcon = parameters.FluentIcon,
          WorkFlowIcon = parameters.WorkFlowIcon,
          AppIcon = parameters.AppIcon,
          Label = parameters.Label,
          Slug = parameters.Slug,
          RedirectURL = parameters.RedirectURL,
          otherParams = _objectWithoutPropertiesLoose(parameters, ["FluentIcon", "WorkFlowIcon", "AppIcon", "Label", "Slug", "RedirectURL"]);

      var formattedParameters = {
        id: item.menuItemInstance.menuItemInstanceId,
        label: Label != null ? Label : '',
        link: Slug != null ? Slug : '',
        redirectInfo: RedirectURL != null ? RedirectURL : '',
        menuItemId: item.menuItemInstance.menuItemId,
        menuStructureId: item.menuStructureId,
        parentId: item.parentId,
        productId: item.menuItemInstance.productId,
        isActive: item.menuItemInstance.isActive,
        roleIds: item.menuItemInstance.roleIds,
        params: _extends({}, otherParams)
      };
      var iconName = '';

      if (FluentIcon) {
        iconName = FluentIcon;
      } else if (WorkFlowIcon) {
        iconName = WorkFlowIcon;
      }

      formattedParameters.icon = iconName ? Icons[iconName] : null;
      formattedParameters.iconName = iconName ? iconName : null;
      formattedParameters['items'] = item.menuItemInstanceStructures.length ? getMenuItemsRecursively(item.menuItemInstanceStructures, activeOnly, roleIds) : [];

      if (!roleIds) {
        formattedItems.push(formattedParameters);
      } else {
        var _formattedParameters$2;

        var roleIdMatch = roleIds === null || roleIds === void 0 ? void 0 : roleIds.filter(function (id) {
          var _formattedParameters$;

          return (_formattedParameters$ = formattedParameters.roleIds) === null || _formattedParameters$ === void 0 ? void 0 : _formattedParameters$.includes(id);
        });

        if (roleIdMatch !== null && roleIdMatch !== void 0 && roleIdMatch.length || !((_formattedParameters$2 = formattedParameters.roleIds) !== null && _formattedParameters$2 !== void 0 && _formattedParameters$2.length)) {
          formattedItems.push(formattedParameters);
        }
      }
    } catch (_unused) {}

    return formattedItems;
  }, []);
};

var getRatio = function getRatio(ratio) {
  var r1;
  var r2;

  if (ratio === '1:1') {
    return [r1 = 1, r2 = 1];
  } else if (ratio === '1:2') {
    return [r1 = 2, r2 = 1];
  } else if (ratio === '16:9') {
    return [r1 = 9, r2 = 16];
  } else if (ratio === '3:2') {
    return [r1 = 2, r2 = 3];
  } else if (ratio === '4:3') {
    return [r1 = 3, r2 = 4];
  } else {
    return [r1 = 1, r2 = 1];
  }
};

var createRatio = function createRatio(width, ratio1, ratio2) {
  var x = width * ratio1 / ratio2;
  return Math.ceil(x / 8) * 8;
};

var useStyles$G = makeStyles(function (theme) {
  return {
    root: {
      width: function width(props) {
        return props.width;
      },
      padding: theme.spacing(1)
    }
  };
});
var GridUnit = function GridUnit(props) {
  var classes = useStyles$G(props);
  var children = props.children,
      columnPadding = props.columnPadding,
      width = props.width,
      ratio = props.ratio;
  var ratioArr = getRatio(ratio);
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root,
    style: {
      height: createRatio(width, ratioArr[0], ratioArr[1]) - (columnPadding || 8)
    }
  }, children);
};

var useStyles$H = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      background: function background(highlight) {
        return highlight === true && lighten('#40c4ff', 0.9);
      }
    }
  };
});
var GridRow = function GridRow(_ref) {
  var children = _ref.children,
      highlight = _ref.highlight,
      className = _ref.className;
  var classes = useStyles$H(highlight);

  var _useState = useState(),
      childCount = _useState[0],
      setChildCount = _useState[1];

  useEffect(function () {
    var count = Children.count(children);
    setChildCount(count);
  }, [childCount, children]);
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, children);
};

var GridGroup = function GridGroup(_ref) {
  var col1 = _ref.col1,
      col2 = _ref.col2,
      col3 = _ref.col3,
      col4 = _ref.col4,
      col5 = _ref.col5,
      col6 = _ref.col6,
      ratio = _ref.ratio,
      highlight = _ref.highlight;
  var theme = useTheme();
  var cnt = Children.toArray(col1).length;
  var cnt2 = Children.toArray(col2).length;
  var cnt3 = Children.toArray(col3).length;
  var cnt4 = Children.toArray(col4).length;
  var cnt5 = Children.toArray(col5).length;
  var cnt6 = Children.toArray(col6).length;
  var number = cnt + cnt2 + cnt3 + cnt4 + cnt5 + cnt6;
  var width = theme.spacing(154) / number / 8;
  var ratioArr = getRatio(ratio);
  var staticDisplay = /*#__PURE__*/React.createElement(GridRow, {
    highlight: highlight
  }, number >= 1 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col1), number >= 2 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col2), number >= 3 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col3), number >= 4 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col4), number >= 5 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col5), number >= 6 && /*#__PURE__*/React.createElement(GridUnit, {
    width: theme.spacing(width),
    columnPadding: 8 * number - 8,
    r1: ratioArr[0],
    r2: ratioArr[1]
  }, col6));
  return /*#__PURE__*/React.createElement("div", null, " ", staticDisplay, " ");
};

var useStyles$I = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      background: function background(highlight) {
        return highlight === true && lighten('#40c4ff', 0.9);
      }
    }
  };
});
var GridRow$1 = function GridRow(_ref) {
  var children = _ref.children,
      highlight = _ref.highlight,
      className = _ref.className;
  var classes = useStyles$I(highlight);

  var _useState = useState(),
      childCount = _useState[0],
      setChildCount = _useState[1];

  useEffect(function () {
    var count = Children.count(children);
    setChildCount(count);
  }, [childCount, children]);
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, children);
};

var getRatio$1 = function getRatio(ratio) {
  var r1;
  var r2;

  if (ratio === '1:1') {
    return [r1 = 1, r2 = 1];
  } else if (ratio === '1:2') {
    return [r1 = 2, r2 = 1];
  } else if (ratio === '16:9') {
    return [r1 = 9, r2 = 16];
  } else if (ratio === '3:2') {
    return [r1 = 2, r2 = 3];
  } else if (ratio === '4:3') {
    return [r1 = 3, r2 = 4];
  } else {
    return [r1 = 1, r2 = 1];
  }
};

var createRatio$1 = function createRatio(width, ratio1, ratio2) {
  var x = width * ratio1 / ratio2;
  return Math.ceil(x / 8) * 8;
};

var useStyles$J = makeStyles(function (theme) {
  return {
    root: {
      width: function width(props) {
        return props.width;
      },
      padding: theme.spacing(1)
    }
  };
});
var GridUnit$1 = function GridUnit(props) {
  var classes = useStyles$J(props);
  var children = props.children,
      columnPadding = props.columnPadding,
      width = props.width,
      ratio = props.ratio;
  var ratioArr = getRatio$1(ratio);
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root,
    style: {
      height: createRatio$1(width, ratioArr[0], ratioArr[1]) - (columnPadding || 8)
    }
  }, children);
};

var useStyles$K = makeStyles(function (theme) {
  return {
    highlight: {
      background: 'pink',
      opacity: function opacity(props) {
        return props.highlight ? 0.2 : 0;
      }
    },
    xxs: {
      height: theme.spacing(2)
    },
    xs: {
      height: theme.spacing(3)
    },
    sm: {
      height: theme.spacing(4)
    },
    md: {
      height: theme.spacing(5)
    },
    lg: {
      height: theme.spacing(8)
    },
    xl: {
      height: theme.spacing(12)
    },
    xxl: {
      height: theme.spacing(20)
    }
  };
});
var LayoutUnit = function LayoutUnit(props) {
  var classes = useStyles$K(props);
  var spaceUnit = '';
  var unit = props.unit,
      highlight = props.highlight;

  switch (unit) {
    case 'xxs':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.xxs, classes.highlight)
      }, highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "XXS"
      }));
      break;

    case 'xs':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.xs, classes.highlight)
      }, highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "XS"
      }), ' ');
      break;

    case 'sm':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.sm, classes.highlight)
      }, ' ', highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "SM"
      }), ' ');
      break;

    case 'md':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.md, classes.highlight)
      }, ' ', highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "MD"
      }), ' ');
      break;

    case 'lg':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.lg, classes.highlight)
      }, ' ', highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "LG"
      }), ' ');
      break;

    case 'xl':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.xl, classes.highlight)
      }, ' ', highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "XL"
      }), ' ');
      break;

    case 'xxl':
      spaceUnit = /*#__PURE__*/React.createElement("div", {
        className: clsx(classes.xxl, classes.highlight)
      }, ' ', highlight && /*#__PURE__*/React.createElement(Badge, {
        color: "secondary",
        badgeContent: "XXL"
      }), ' ');
      break;
  }

  return spaceUnit;
};

var verticalPrimary = function verticalPrimary(vertical) {
  if (vertical === 'manage') {
    return '#2951B8';
  } else if (vertical === 'engage') {
    return '#9A1A5F';
  } else if (vertical === 'play') {
    return '#008383';
  } else if (vertical === 'build') {
    return '#CE4A00';
  } else if (vertical === 'unity') {
    return '#0C2F50';
  } else {
    return '#161616';
  }
};
var verticalSecondary = function verticalSecondary(vertical) {
  if (vertical === 'manage') {
    return '#09A58C';
  } else if (vertical === 'engage') {
    return '#9A1A5F';
  } else if (vertical === 'play') {
    return '#008383';
  } else if (vertical === 'build') {
    return '#CE4A00';
  } else if (vertical === 'unity') {
    return '#03BBC3';
  } else {
    return '#0f62fe';
  }
};
var useTypeScale = function useTypeScale() {
  var _useState = useState({
    size: '4.25rem',
    weight: 600,
    lineHeight: 1,
    letterSpacing: -1.5
  }),
      h1 = _useState[0];

  var _useState2 = useState({
    size: '2.625rem',
    weight: 300,
    lineHeight: 1,
    letterSpacing: -0.5
  }),
      h2 = _useState2[0];

  var _useState3 = useState({
    size: '2rem',
    weight: 400,
    lineHeight: 1,
    letterSpacing: 0
  }),
      h3 = _useState3[0];

  var _useState4 = useState({
    size: '1.5rem',
    weight: 400,
    lineHeight: 1,
    letterSpacing: 0.25
  }),
      h4 = _useState4[0];

  var _useState5 = useState({
    size: '1.2715rem',
    weight: 400,
    lineHeight: 1,
    letterSpacing: 0
  }),
      h5 = _useState5[0];

  var _useState6 = useState({
    size: '1.1875rem',
    weight: 600,
    lineHeight: 1,
    letterSpacing: 0.15
  }),
      h6 = _useState6[0];

  var _useState7 = useState({
    size: '1rem',
    weight: 400,
    lineHeight: 1,
    letterSpacing: 0.15
  }),
      subtitle1 = _useState7[0];

  var _useState8 = useState({
    size: '0.875rem',
    weight: 600,
    lineHeight: 1,
    letterSpacing: 0.1
  }),
      subtitle2 = _useState8[0];

  var _useState9 = useState({
    size: '0.875rem',
    weight: 400,
    lineHeight: 1.25,
    letterSpacing: 0.5
  }),
      body1 = _useState9[0];

  var _useState10 = useState({
    size: '1rem',
    weight: 400,
    lineHeight: 1.25,
    letterSpacing: 0.25
  }),
      body2 = _useState10[0];

  var _useState11 = useState({
    size: '0.875rem',
    weight: 600,
    lineHeight: 1,
    letterSpacing: 0.15
  }),
      button = _useState11[0];

  var _useState12 = useState({
    size: '0.75rem',
    weight: 600,
    lineHeight: 1,
    letterSpacing: 0.4
  }),
      caption = _useState12[0];

  var _useState13 = useState({
    size: '0.625rem',
    weight: 400,
    lineHeight: 1,
    letterSpacing: 1.5
  }),
      overline = _useState13[0];

  return [h1, h2, h3, h4, h5, h6, body1, body2, subtitle1, subtitle2, button, caption, overline];
};

var StatusChip = function StatusChip(_ref) {
  var status = _ref.status,
      label = _ref.label,
      success = _ref.success,
      warning = _ref.warning,
      error = _ref.error,
      info = _ref.info;
  var type = '';
  var highlight = 0.8;
  var theme = useTheme();

  switch (status) {
    case !success ? 'success' : success:
      type = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten(theme.palette.success.main, highlight)
        },
        label: label,
        size: "small"
      });
      break;

    case !warning ? 'warning' : warning:
      type = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten(theme.palette.warning.main, highlight)
        },
        label: label,
        size: "small"
      });
      break;

    case !error ? 'error' : error:
      type = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten(theme.palette.error.main, highlight)
        },
        label: label,
        size: "small"
      });
      break;

    case !info ? 'info' : info:
      type = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten(theme.palette.info.main, highlight)
        },
        label: label,
        size: "small"
      });
      break;
  }

  return type;
};

var useStyles$L = makeStyles(function (theme) {
  return {
    divider: {
      marginTop: theme.spacing(1)
    },
    content: {
      marginLeft: theme.spacing(4)
    }
  };
});
var DirectoryListItem = function DirectoryListItem(_ref) {
  var children = _ref.children,
      letter = _ref.letter;
  var classes = useStyles$L();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Typography, {
    variant: "h4"
  }, letter)), /*#__PURE__*/React.createElement("div", {
    className: classes.content
  }, children, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Divider, {
    className: classes.divider
  }))));
};

var useStyles$M = makeStyles(function (theme) {
  return {
    root: {}
  };
});
var Directory = function Directory(_ref) {
  var data = _ref.data,
      success = _ref.success,
      warning = _ref.warning,
      error = _ref.error,
      info = _ref.info,
      key = _ref.key,
      statusKey = _ref.statusKey;
  var classes = useStyles$M();
  var dataTransform = data.reduce(function (r, e) {
    var alphabet = e.name[0];
    if (!r[alphabet]) r[alphabet] = {
      alphabet: alphabet,
      record: [e]
    };else r[alphabet].record.push(e);
    return r;
  }, {});
  var result = Object.values(dataTransform);
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, result.map(function (item) {
    return /*#__PURE__*/React.createElement(DirectoryListItem, {
      key: key,
      letter: item.alphabet
    }, item.record.map(function (item) {
      return /*#__PURE__*/React.createElement("div", {
        style: {
          marginBottom: 8
        },
        key: statusKey
      }, /*#__PURE__*/React.createElement(StatusChip, {
        success: success,
        warning: warning,
        error: error,
        info: info,
        label: item.name,
        status: item.status
      }));
    }));
  }));
};

var TrimForAvatar = function TrimForAvatar(avatar) {
  var _avatar$trim;

  return (avatar === null || avatar === void 0 ? void 0 : (_avatar$trim = avatar.trim()) === null || _avatar$trim === void 0 ? void 0 : _avatar$trim.charAt(0)) || '?';
};

var useStyles$N = makeStyles(function (theme) {
  return {
    root: {
      width: '100%',
      display: 'flex'
    },
    avatar: {
      marginRight: theme.spacing(2)
    },
    message: {
      width: '100%'
    },
    noteWrapper: {
      display: 'flex'
    },
    note: {
      flex: 1
    },
    date: {
      marginTop: theme.spacing(2)
    }
  };
});
var Note = function Note(_ref) {
  var children = _ref.children,
      author = _ref.author,
      date = _ref.date,
      className = _ref.className,
      onClick = _ref.onClick;
  var classes = useStyles$N();
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.avatar
  }, /*#__PURE__*/React.createElement(AvatarAlphabet$1, {
    avatarCharacter: TrimForAvatar(author)
  })), /*#__PURE__*/React.createElement(Paper, {
    elevation: 0,
    className: classes.message
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("div", {
    className: classes.noteWrapper
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "body2",
    className: classes.note
  }, children), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    color: "primary",
    icon: DeleteIcon,
    onClick: onClick
  }))), /*#__PURE__*/React.createElement("div", {
    className: classes.date
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, /*#__PURE__*/React.createElement(TimeAgo, {
    datetime: date
  }))))));
};

var useStyles$O = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      alignContent: 'space-around'
    }
  };
});
var Notes = function Notes(_ref) {
  var data = _ref.data,
      key = _ref.key,
      handleClick = _ref.handleClick;
  var classes = useStyles$O();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, data && data.map(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        marginBottom: 20
      },
      key: key
    }, /*#__PURE__*/React.createElement(Note, {
      author: item.author,
      date: item.date.toString(),
      onClick: function onClick() {
        return handleClick(item.id);
      }
    }, item.note));
  }));
};

var useStyles$P = makeStyles({
  root: {}
}, {
  name: 'FluentCard'
});
var FluentCard = forwardRef(function (props, ref) {
  var classes = useStyles$P(props);

  var children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(Card, _extends({
    ref: ref,
    square: true
  }, other, {
    classes: classes
  }), children);
});
FluentCard.displayName = 'FluentCard';

var useStyles$Q = makeStyles(function (theme) {
  return {
    root: {
      width: '100%',
      height: '100%'
    },
    large: {
      width: theme.spacing(12),
      height: theme.spacing(12),
      border: "3px solid " + theme.palette.primary.main
    },
    info: {
      display: 'flex',
      marginTop: theme.spacing(3)
    },
    header: {
      display: 'flex'
    },
    addressContainer: {
      maxWidth: theme.spacing(16),
      alignContent: 'center',
      marginLeft: theme.spacing(3),
      marginBottom: theme.spacing(3)
    },
    lastName: {
      marginTop: theme.spacing(-1)
    },
    name: {
      flex: 1
    },
    chip: {
      background: lighten(theme.palette.success.light, 0.7)
    }
  };
});
var BioCard = function BioCard(_ref) {
  var children = _ref.children,
      avatar = _ref.avatar,
      alt = _ref.alt,
      firstName = _ref.firstName,
      lastName = _ref.lastName,
      address = _ref.address,
      copy = _ref.copy,
      className = _ref.className;
  var classes = useStyles$Q();

  var _useState = useState({
    value: '',
    copied: false
  }),
      state = _useState[0],
      setState = _useState[1];

  useEffect(function () {
    setState({
      value: copy
    });
  }, [copy]);
  return /*#__PURE__*/React.createElement(FluentCard, {
    className: clsx(classes.root, className)
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement("div", {
    className: classes.header
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.name
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "h4"
  }, firstName, " "), /*#__PURE__*/React.createElement("div", {
    className: classes.lastName
  }, /*#__PURE__*/React.createElement(Typography, {
    className: classes.overline,
    variant: "overline"
  }, lastName))), copy && !state.copied && /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(CopyToClipboard, {
    text: state.value,
    onCopy: function onCopy() {
      return setState(_extends({}, state, {
        copied: true
      }));
    }
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    color: "primary",
    icon: CopyIcon
  }))), state.copied && /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Chip, {
    label: "Copied",
    avatar: /*#__PURE__*/React.createElement(CheckMarkIcon, null),
    variant: "outlined",
    className: classes.chip,
    size: "small"
  }))), /*#__PURE__*/React.createElement("div", {
    className: classes.info
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.avatarWrapper
  }, /*#__PURE__*/React.createElement(Avatar, {
    className: classes.large,
    alt: alt,
    src: avatar
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.addressContainer
  }, address))), children && /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(CardContent, null, children));
};

var useStyles$R = makeStyles(function (theme) {
  return {
    divider: {
      marginTop: theme.spacing(1),
      marginBottom: theme.spacing(1)
    }
  };
});
var AddressListItem = function AddressListItem(_ref) {
  var children = _ref.children;
  var classes = useStyles$R();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "body2",
    className: classes.divider
  }, children), /*#__PURE__*/React.createElement(Divider, null));
};

var SubHeaderActions = createTeleporter({
  multiSources: true
});
var SubHeaderActionsTarget = SubHeaderActions.Target;
var SubHeaderAction = function SubHeaderAction(props) {
  var children = props.children,
      buttonProps = _objectWithoutPropertiesLoose(props, ["children", "className"]);

  return /*#__PURE__*/React.createElement(SubHeaderActions.Source, null, children);
};

var useStyles$S = makeStyles(function (theme) {
  return {
    root: {
      background: theme.palette.primary.light,
      minHeight: theme.spacing(12)
    },
    bar: {
      display: 'flex',
      flexDirection: 'row'
    },
    gutters: {
      paddingLeft: theme.spacing(2)
    },
    content: {
      flex: 1
    },
    collapsed: {
      height: 0,
      transition: theme.transitions.create('height', {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.leavingScreen
      })
    },
    expanded: {
      transition: theme.transitions.create('height', {
        easing: theme.transitions.easing.easeIn,
        duration: theme.transitions.duration.enteringScreen
      })
    },
    open: {
      display: 'flex',
      justifyContent: 'flex-end'
    },
    toggleButton: {
      padding: theme.spacing(1)
    }
  };
}, {
  name: 'UtilityBar'
});
var UtilityBar = function UtilityBar(props) {
  var classes = useStyles$S();
  var _props$expanded = props.expanded,
      expanded = _props$expanded === void 0 ? true : _props$expanded,
      toggle = props.toggle,
      _props$gutters = props.gutters,
      gutters = _props$gutters === void 0 ? true : _props$gutters,
      className = props.className;
  return /*#__PURE__*/React.createElement(Fragment$1, null, expanded && /*#__PURE__*/React.createElement(Card, {
    className: clsx(classes.root, className, expanded ? classes.expanded : classes.collapsed),
    variant: "outlined",
    square: true
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.bar, gutters && classes.gutters)
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.content
  }, /*#__PURE__*/React.createElement(SubHeaderActionsTarget, {
    className: classes.actions
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.toggleButton
  }, /*#__PURE__*/React.createElement(IconButton, {
    onClick: toggle,
    "aria-label": "Toggle Utility Bar"
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    size: "small",
    component: ChromeCloseIcon
  })))))), !expanded && /*#__PURE__*/React.createElement("div", {
    className: classes.open
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.bar
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.toggleButton
  }, /*#__PURE__*/React.createElement(IconButton, {
    onClick: toggle
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    size: "small",
    component: ChevronDownMedIcon
  }))))));
};

var ChipAlphabet = function ChipAlphabet(_ref) {
  var avatarCharacter = _ref.avatarCharacter,
      label = _ref.label,
      handleClick = _ref.handleClick,
      avatar = _ref.avatar;
  var letter = '';
  var highlight = 0.8;

  switch (avatarCharacter) {
    case 'A':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#FFB900', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'B':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#E74856', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'C':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#0078D7', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'D':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#0099BC', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'E':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#7A7574', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'F':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#0078D7', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'G':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#FF8C00', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'H':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#E81123', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'I':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#0063B1', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        })
      });
      break;

    case 'J':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#2D7D9A', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'K':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#5D5A58', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'L':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#4C4A48', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'M':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#F7630C', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'N':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#EA005E', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'O':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#8E8CD8', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'P':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#00B7C3', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'Q':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#68768A', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'R':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#69797E', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'S':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#CA5010', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'T':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#C30052', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'U':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('FF4343', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'V':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#9A0089', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'W':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#10893E', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'X':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#567C73', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'Y':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#018574', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;

    case 'Z':
      letter = /*#__PURE__*/React.createElement(Chip, {
        style: {
          backgroundColor: lighten('#881798', highlight)
        },
        label: label,
        size: "small",
        avatar: /*#__PURE__*/React.createElement(AvatarAlphabet, {
          size: "small",
          avatarCharacter: avatar && avatarCharacter
        }),
        onClick: handleClick,
        clickable: true
      });
      break;
  }

  return letter;
};

var useStyles$T = makeStyles(function (theme) {
  return {
    root: {},
    paper: {
      background: lighten(theme.palette.info.light, 0.8),
      borderTop: "5px solid " + theme.palette.info.main + " "
    },
    title: {
      color: theme.palette.info.dark,
      highlightfontWeight: 400,
      lineHeight: 1.6
    },
    subHeader: {
      lineHeight: 1.6,
      fontWeight: 600
    }
  };
});
var InfoCard = function InfoCard(_ref) {
  var children = _ref.children,
      title = _ref.title,
      subTitle = _ref.subTitle,
      relatedTopics = _ref.relatedTopics,
      label = _ref.label,
      _ref$headerComponent = _ref.headerComponent,
      headerComponent = _ref$headerComponent === void 0 ? 'h2' : _ref$headerComponent,
      _ref$subHeaderCompone = _ref.subHeaderComponent,
      subHeaderComponent = _ref$subHeaderCompone === void 0 ? 'h3' : _ref$subHeaderCompone,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'standard' : _ref$size;
  var classes = useStyles$T();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(FluentCard$1, {
    elevation: 0,
    classes: {
      root: classes.paper
    }
  }, /*#__PURE__*/React.createElement(CardContent, null, /*#__PURE__*/React.createElement(Typography, {
    variant: "h6",
    component: headerComponent,
    className: classes.title
  }, title), size === 'standard' && /*#__PURE__*/React.createElement(LayoutUnit$1, {
    unit: "xxs"
  }), /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2",
    component: subHeaderComponent,
    className: classes.subHeader
  }, subTitle), children, size === 'standard' && /*#__PURE__*/React.createElement(LayoutUnit$1, {
    unit: "xxs"
  }), relatedTopics && /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(LayoutUnit$1, {
    unit: "xxs"
  }), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, label || 'Related Topics'), /*#__PURE__*/React.createElement(LayoutUnit$1, {
    unit: "xxs"
  }), relatedTopics))));
};
InfoCard.propTypes = {
  children: propTypes.oneOfType([propTypes.arrayOf(propTypes.node), propTypes.node]),
  title: propTypes.string.isRequired,
  subTitle: propTypes.string,
  relatedTopics: propTypes.oneOfType([propTypes.arrayOf(propTypes.node), propTypes.node]),
  label: propTypes.string,
  headerComponent: propTypes.string,
  subHeaderComponent: propTypes.string,
  size: propTypes.oneOf(['standard'])
};
InfoCard.defaultProps = {
  headerComponent: 'h2',
  subHeaderComponent: 'h3',
  size: 'standard'
};

var useStyles$U = makeStyles(function (theme) {
  return {
    root: {
      minHeight: 40,
      paddingLeft: theme.spacing(2),
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'center',
      borderBottom: "1px solid " + theme.palette.divider
    },
    title: {
      flexGrow: 1
    }
  };
});

var FUICardHeader = function FUICardHeader(props, ref) {
  var classes = useStyles$U(props);

  var className = props.className,
      children = props.children,
      headerActions = props.headerActions,
      titleId = props.titleId,
      other = _objectWithoutPropertiesLoose(props, ["className", "children", "headerActions", "titleId"]);

  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, other, {
    className: clsx(className, classes.root)
  }), /*#__PURE__*/React.createElement(Typography, {
    id: titleId,
    className: classes.title
  }, children), headerActions);
};

var FUICardHeader$1 = forwardRef(FUICardHeader);

var useStyles$V = makeStyles(function (theme) {
  return {
    root: {
      borderRadius: 0
    }
  };
}, {
  name: 'FUISquareIconButton'
});

var FUISquareIconButton = function FUISquareIconButton(props) {
  var classes = useStyles$V(props);
  return /*#__PURE__*/React.createElement(IconButton, _extends({}, props, {
    classes: classes
  }));
};

var useStyles$W = makeStyles({
  root: {}
}, {
  name: 'FluentCardContent'
});
var FluentCardContent = forwardRef(function (props, ref) {
  var classes = useStyles$W(props);

  var children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(CardContent, _extends({
    ref: ref
  }, other, {
    classes: classes
  }), children);
});
FluentCardContent.displayName = 'FluentCardContent';

var useStyles$X = makeStyles({
  root: {},
  spacing: {}
}, {
  name: 'FluentCardActions'
});
var FluentCardActions = forwardRef(function (props, ref) {
  var classes = useStyles$X(props);

  var children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(CardActions, _extends({
    ref: ref
  }, other, {
    classes: classes
  }), children);
});
FluentCardActions.displayName = 'FluentCardActions';

var idCounter = 0;

function nextId() {
  idCounter += 1;
  warning(idCounter < 1e10, 'Id: you might have a memory leak.' + 'The idCounter is not supposed to grow that much.');
  return idCounter;
}

function useId(name, idFromProps) {
  var id = useConstant(nextId);

  if (idFromProps) {
    return idFromProps;
  }

  if (process.env.NODE_ENV === 'production') {
    return "uid" + id;
  }

  return (name || 'unnamed') + "-" + id;
}

var useStyles$Y = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column'
    },
    raised: {
      zIndex: 1
    },
    contentArea: {
      flex: '1 1 auto',
      minHeight: 0,
      display: 'flex',
      flexDirection: 'column'
    },
    cardActions: {
      display: 'flex',
      flexDirection: 'row',
      justifyContent: 'flex-start',
      paddingTop: theme.spacing(1),
      padding: theme.spacing(2)
    }
  };
}, {
  name: 'FUICard'
});
var FUICardAction = function FUICardAction(props, ref) {
  var children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["children"]);

  return /*#__PURE__*/React.createElement(Button, _extends({
    ref: ref,
    size: "small",
    variant: "contained",
    disableElevation: true
  }, other), children);
};
FUICardAction = forwardRef(FUICardAction);
var FUICardHeaderMenu = function FUICardHeaderMenu(props, ref) {
  var children = props.children;
  return /*#__PURE__*/React.createElement("div", {
    button: /*#__PURE__*/React.createElement(FUISquareIconButton, null, /*#__PURE__*/React.createElement(FluentIcon, {
      component: MoreIcon,
      size: "small"
    })),
    menu: /*#__PURE__*/React.createElement(Menu, null, children)
  });
};
FUICardHeaderMenu = forwardRef(FUICardHeaderMenu);

var FUICard = function FUICard(props, ref) {
  var classes = useStyles$Y();

  var className = props.className,
      children = props.children,
      actions = props.actions,
      title = props.title,
      headerActions = props.headerActions,
      CardHeaderProps = props.CardHeaderProps,
      CardProps = props.CardProps,
      raised = props.raised,
      name = props.name,
      cardProps = _objectWithoutPropertiesLoose(props, ["className", "children", "actions", "title", "headerActions", "CardHeaderProps", "CardProps", "raised", "name"]);

  var id = useId(name, cardProps.id);
  var titleId = id + "-title";
  return /*#__PURE__*/React.createElement(FluentCard, _extends({
    ref: ref,
    component: "section",
    "aria-labelledby": titleId
  }, cardProps, {
    raised: raised,
    className: clsx(className, raised && classes.raised)
  }, CardProps, {
    classes: {
      root: classes.root
    }
  }), /*#__PURE__*/React.createElement(FUICardHeader$1, _extends({
    titleId: titleId,
    headerActions: headerActions
  }, CardHeaderProps), title), /*#__PURE__*/React.createElement(FluentCardContent, {
    className: classes.contentArea
  }, children), actions && /*#__PURE__*/React.createElement(FluentCardActions, {
    className: classes.cardActions
  }, actions));
};

var FUICard$1 = forwardRef(FUICard);

var useStyles$Z = makeStyles({
  listItemIcon: {
    minWidth: 32
  }
}, {
  name: 'FUIMenuItem'
});

var FUIMenuItem = function FUIMenuItem(props, ref) {
  var classes = useStyles$Z();

  var icon = props.icon,
      fluentIcon = props.fluentIcon,
      primary = props.primary,
      secondary = props.secondary,
      menuItemProps = _objectWithoutPropertiesLoose(props, ["icon", "fluentIcon", "primary", "secondary"]);

  return /*#__PURE__*/React.createElement(MenuItem, _extends({
    ref: ref,
    dense: true
  }, menuItemProps), /*#__PURE__*/React.createElement(ListItemIcon, {
    className: classes.listItemIcon
  }, icon || /*#__PURE__*/React.createElement(FluentIcon, {
    component: fluentIcon
  })), /*#__PURE__*/React.createElement(ListItemText, {
    primary: primary,
    secondary: secondary
  }));
};

var FUIMenuItem$1 = forwardRef(FUIMenuItem);

var WidgetCard = function WidgetCard(props) {
  var children = props.children,
      headerActions = props.headerActions,
      className = props.className,
      widgetType = props.widgetType,
      onDelete = props.onDelete,
      loading = props.loading,
      errors = props.errors,
      theme = props.theme,
      other = _objectWithoutPropertiesLoose(props, ["children", "headerActions", "className", "widgetType", "id", "layout", "params", "setParam", "onDelete", "loading", "errors", "theme"]);

  var useStyles = makeStyles(function (theme) {
    return {
      root: {
        '&.react-resizable-hide .react-resizable-handle': {
          display: 'none'
        }
      },
      darkRoot: {
        '&.react-resizable-hide .react-resizable-handle': {
          display: 'none'
        },
        background: '#424242',
        color: 'white'
      },
      anyRoot: {
        '& .MuiCardContent-root': {
          justifyContent: 'space-between',
          overflow: 'auto',
          padding: 0
        }
      },
      handle: {
        cursor: 'move',
        '&:hover': {
          backgroundColor: theme.palette.action.hover
        }
      },
      loadingContent: {
        flex: 1,
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        justifyContent: 'center'
      },
      innerWidgetContentContainer: {
        height: '100%',
        minWidth: widgetType === 'ProgressBarWidget' ? 0 : 270,
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'space-between',
        padding: theme.spacing(2)
      }
    };
  });
  var classes = useStyles();
  var raised = /(^|\s)react-draggable-dragging(\s|$)/.test(className != null ? className : '');
  var body = children;

  if (loading) {
    body = /*#__PURE__*/React.createElement("div", {
      className: classes.loadingContent
    }, /*#__PURE__*/React.createElement(CircularProgress, {
      color: "secondary",
      size: 64
    }));
  }

  if (errors && !body) {
    body = /*#__PURE__*/React.createElement("div", null, "Unexpected error");
  }

  return /*#__PURE__*/React.createElement(FUICard$1, _extends({}, other, {
    className: clsx(className, theme === 'dark' ? classes.darkRoot : classes.root, classes.anyRoot),
    raised: raised,
    CardHeaderProps: {
      className: classes.handle,
      'data-handle': true
    },
    headerActions: /*#__PURE__*/React.createElement(Fragment$1, null, headerActions, /*#__PURE__*/React.createElement(FUICardHeaderMenu, null, /*#__PURE__*/React.createElement(FUIMenuItem$1, {
      onClick: onDelete,
      fluentIcon: DeleteIcon,
      primary: "Delete"
    })))
  }), /*#__PURE__*/React.createElement("div", {
    className: classes.innerWidgetContentContainer
  }, body));
};

var useStyles$_ = makeStyles(function (theme) {
  return {
    root: {},
    DownArrow: {
      color: colors.red[500],
      fontSize: 16
    },
    UpArrow: {
      color: colors.green[500],
      fontSize: 16
    }
  };
});

var FluentTrendArrow = function FluentTrendArrow(props) {
  var type = props.type;
  var classes = useStyles$_();
  var trend = '';

  switch (type) {
    case 'up':
      trend = /*#__PURE__*/React.createElement(UpArrow, {
        className: classes.UpArrow
      });
      break;

    case 'down':
      trend = /*#__PURE__*/React.createElement(DownArrow, {
        className: classes.DownArrow
      });
      break;
  }

  return trend;
};

var useStyles$$ = makeStyles(function (theme) {
  return {
    root: {},
    percent: {
      display: 'flex',
      flexDirection: 'row',
      marginTop: theme.spacing(-0.5)
    },
    arrow: {
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'center'
    },
    percentAmount: {}
  };
});

var FluentStatsSnippet = function FluentStatsSnippet(props) {
  var classes = useStyles$$(props);
  var label = props.label,
      rawAmount = props.amount,
      prevAmount = props.prevAmount,
      percentProp = props.percent,
      trendProp = props.trend;
  var amount = rawAmount;

  if (Math.abs(rawAmount) > 1000000) {
    var newNumber = rawAmount / 1000000;
    amount = [Math.round(newNumber * 10) / 10, 'M'];
  } else if (Math.abs(rawAmount) > 1000) {
    var _newNumber = rawAmount / 1000;

    amount = [Math.round(_newNumber * 10) / 10, 'K'];
  }

  var percent = percentProp;
  var trend = trendProp;

  if (typeof prevAmount === 'number') {
    var ratio = (rawAmount - prevAmount) / prevAmount;
    percent = Math.abs(round(ratio * 100, Math.abs(ratio) < 0.01 ? 0.01 : 1)) + '%';
    trend = ratio < 0 ? 'down' : 'up';
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "overline",
    component: "div"
  }, label), /*#__PURE__*/React.createElement(Typography, {
    className: classes.stat,
    variant: "h5",
    component: "div"
  }, amount), /*#__PURE__*/React.createElement("div", {
    className: classes.percent
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.arrow
  }, /*#__PURE__*/React.createElement(FluentTrendArrow, {
    type: trend
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.percentAmount
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, percent))));
};

var convertISODate = function convertISODate(isoDate) {
  var date = new Date(isoDate);
  return date.toLocaleDateString('en-US');
};

var layout = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var params = {
  mode: {
    defaultValue: 'chart'
  }
};

var BarChartWidget = function BarChartWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme && theme
  }), mockData ? /*#__PURE__*/React.createElement(Fragment$1, null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "From: ", convertISODate(dateRange.from), " to:", ' ', convertISODate(dateRange.to)), (mockData === null || mockData === void 0 ? void 0 : mockData.stats) && /*#__PURE__*/React.createElement(Grid$1, {
    container: true
  }, mockData === null || mockData === void 0 ? void 0 : mockData.stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      xs: 3,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.currentValue,
      prevAmount: stat.previousValue
    }));
  })), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    width: "container",
    height: "container",
    autoResize: "true",
    variant: "verticalBarChart",
    spec: {
      $schema: 'https://vega.github.io/schema/vega-lite/v4.json',
      data: {
        values: mockData === null || mockData === void 0 ? void 0 : mockData.data
      },
      mark: 'bar',
      encoding: {
        x: {
          field: 'xAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.xAxisType,
          axis: {
            ticks: false
          },
          band: 0.5
        },
        y: {
          field: 'yAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisType,
          axis: {
            format: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisFormat
          }
        }
      }
    }
  })), children) : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var BarChartWidget$1 = forwardRef(BarChartWidget);

var BarChartWidget$2 = {
  __proto__: null,
  layout: layout,
  params: params,
  'default': BarChartWidget$1
};

var useStyles$10 = makeStyles(function (theme) {
  return {
    root: {
      minWidth: 30,
      minHeight: 30,
      maxWidth: 70,
      maxHeight: 70,
      color: theme.palette.primary.dark
    },
    positive: {
      backgroundColor: function backgroundColor(props) {
        return colors.teal[Math.ceil(props.number * 5 / 100) * 100];
      }
    },
    negative: {
      backgroundColor: function backgroundColor(props) {
        return colors.deepOrange[Math.abs(Math.ceil(props.number * 5 / 100) * 100)];
      }
    }
  };
});

var NumberVisualization = function NumberVisualization(props) {
  var classes = useStyles$10(props);
  var number = props.number;
  var displayCircle = '';

  if (number > 0) {
    displayCircle = /*#__PURE__*/React.createElement(Avatar, {
      className: clsx(classes.root, classes.positive),
      style: {
        width: number * 2,
        height: number * 2
      }
    }, number);
  } else {
    displayCircle = /*#__PURE__*/React.createElement(Avatar, {
      className: clsx(classes.root, classes.negative),
      style: {
        width: number * 2,
        height: number * 2
      }
    }, number);
  }

  return /*#__PURE__*/React.createElement(Fragment$1, null, " ", displayCircle, " ");
};

var useStyles$11 = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row',
      marginTop: theme.spacing(3),
      marginLeft: theme.spacing(2),
      overflow: 'auto'
    },
    dot: {
      width: 10,
      height: 10,
      backgroundColor: 'white',
      borderRadius: theme.shape.borderRadius + 25,
      marginTop: theme.spacing(1)
    },
    timeLabels: {
      color: 'white'
    },
    indicator: {
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'flex-end',
      marginRight: theme.spacing(2),
      textAlign: 'center',
      alignItems: 'center'
    }
  };
});

var TimeDot = function TimeDot(props) {
  var classes = useStyles$11();
  var dot = props.dot;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.indicator
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.dot
  }), /*#__PURE__*/React.createElement("div", {
    className: classes.timeLabels
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "overline"
  }, dot)));
};

var Visualization = function Visualization(props) {
  var classes = useStyles$11();
  var value = props.value,
      label = props.label;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.indicator
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(NumberVisualization, {
    number: value
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TimeDot, {
    dot: label
  })));
};

var categoriesToDisplay = function categoriesToDisplay(categories) {
  return categories.map(function (item) {
    return /*#__PURE__*/React.createElement(Visualization, {
      key: item.label,
      value: item.value,
      label: item.label
    });
  });
};

var FluentTimeline = function FluentTimeline(props) {
  var classes = useStyles$11();
  var categories = props.categories;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, categoriesToDisplay(categories));
};

var layout$1 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var params$1 = {
  mode: {
    defaultValue: 'chart'
  }
};

var BubbleWidget = function BubbleWidget(props, ref) {
  var _mockData$stats;

  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }), /*#__PURE__*/React.createElement(Grid$1, {
    container: true
  }, mockData === null || mockData === void 0 ? void 0 : (_mockData$stats = mockData.stats) === null || _mockData$stats === void 0 ? void 0 : _mockData$stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      xs: 3,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.currentValue,
      prevAmount: stat.previousValue
    }));
  })), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(FluentTimeline, {
    categories: mockData === null || mockData === void 0 ? void 0 : mockData.data
  })), children);
};

var BubbleWidget$1 = forwardRef(BubbleWidget);

var BubbleWidget$2 = {
  __proto__: null,
  layout: layout$1,
  params: params$1,
  'default': BubbleWidget$1
};

var useStyles$12 = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    regular: {},
    small: {},
    number: {
      '$regular &': {
        fontSize: '4rem'
      },
      '$small &': {
        fontSize: 30
      }
    },
    unit: {
      marginTop: theme.spacing(5),
      width: 25,
      height: 25,
      '$small &': {
        marginTop: '16px',
        width: '16px',
        height: '16px',
        '& .MuiTypography-subtitle1': {
          fontSize: '0.7rem'
        }
      }
    },
    unitValue: {
      marginTop: -1.75
    }
  };
}, {
  name: 'FluentDisplayNumbers'
});

var FluentDisplayNumbers = function FluentDisplayNumbers(props) {
  var classes = useStyles$12();
  var small = props.small,
      rawNumber = props.number;
  var no = [rawNumber, null];

  if (rawNumber > 1000000) {
    var newNumber = rawNumber / 1000000;
    no = [Math.round(newNumber * 10) / 10, 'M'];
  } else if (rawNumber > 1000) {
    var _newNumber = rawNumber / 1000;

    no = [Math.round(_newNumber * 10) / 10, 'k'];
  }

  var _no = no,
      number = _no[0],
      unit = _no[1];
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, small ? classes.small : classes.regular)
  }, /*#__PURE__*/React.createElement(Typography, {
    className: classes.number
  }, number), unit && /*#__PURE__*/React.createElement(Avatar, {
    className: classes.unit
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle1",
    className: classes.unitValue
  }, unit)));
};

var useStyles$13 = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row'
    },
    caption: {
      marginTop: -28,
      textAlign: 'left'
    },
    captionSmall: {
      marginTop: -16,
      textAlign: 'center'
    },
    trend: {
      marginTop: theme.spacing(2),
      marginLeft: theme.spacing(1)
    },
    upIcon: {
      color: 'green'
    },
    downIcon: {
      color: '#D50000'
    },
    avatar: {
      backgroundColor: 'white'
    }
  };
}, {
  next: 'FluentStatNumber'
});

var FluentStatNumber = function FluentStatNumber(props) {
  var classes = useStyles$13();
  var small = props.small,
      trend = props.trend,
      label = props.label,
      number = props.number;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentDisplayNumbers, {
    small: small,
    number: Math.abs(number)
  })), /*#__PURE__*/React.createElement("div", {
    className: !small ? classes.caption : classes.captionSmall
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "overline"
  }, label))), /*#__PURE__*/React.createElement("div", {
    className: classes.trend
  }, small && /*#__PURE__*/React.createElement(Avatar, {
    className: classes.avatar
  }, trend === 'down' ? /*#__PURE__*/React.createElement(FluentIcon, {
    component: MarketDownIcon,
    className: classes.downIcon
  }) : /*#__PURE__*/React.createElement(FluentIcon, {
    component: MarketIcon,
    className: classes.upIcon
  }))));
};

var useStyles$14 = makeStyles(function (theme) {
  return {
    displayRow: {
      display: 'flex',
      flexDirection: 'row'
    },
    smallDisplay: {
      marginTop: theme.spacing(6),
      marginLeft: theme.spacing(3)
    },
    divider: {
      height: theme.spacing(6),
      marginTop: theme.spacing(6.5),
      marginLeft: theme.spacing(2)
    }
  };
}, {
  next: 'FluentPrimaryStatNumber'
});

var FluentPrimaryStatNumber = function FluentPrimaryStatNumber(props) {
  var classes = useStyles$14();
  var mainStat = props.mainStat,
      mainLabel = props.mainLabel;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.displayRow
  }, /*#__PURE__*/React.createElement(FluentStatNumber, {
    label: mainLabel,
    number: mainStat
  }));
};

var useStyles$15 = makeStyles(function (theme) {
  return {
    displayRow: {
      display: 'flex',
      flexDirection: 'row'
    },
    divider: {
      height: theme.spacing(6),
      marginTop: theme.spacing(6.5),
      marginLeft: theme.spacing(1)
    }
  };
});

var FluentSecondaryStatNumber = function FluentSecondaryStatNumber(props) {
  var classes = useStyles$15();
  var secondaryStat = props.secondaryStat,
      secondaryLabel = props.secondaryLabel,
      trend = props.trend;
  return /*#__PURE__*/React.createElement("div", {
    className: classes.displayRow
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.smallDisplay
  }, /*#__PURE__*/React.createElement(FluentStatNumber, {
    small: true,
    trend: trend,
    label: secondaryLabel,
    number: secondaryStat
  })));
};

var useStyles$16 = makeStyles(function (theme) {
  return {
    column: {
      width: 160
    }
  };
});
var layout$2 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};

var DateTrendWidget = function DateTrendWidget(props, ref) {
  var classes = useStyles$16();

  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }), /*#__PURE__*/React.createElement(Grid$1, {
    container: true,
    direction: "row",
    spacing: 1
  }, /*#__PURE__*/React.createElement(Grid$1, {
    item: true,
    className: classes.column
  }, /*#__PURE__*/React.createElement(FluentPrimaryStatNumber, {
    mainStat: mockData === null || mockData === void 0 ? void 0 : mockData.primary.value,
    mainLabel: mockData === null || mockData === void 0 ? void 0 : mockData.primary.label
  })), /*#__PURE__*/React.createElement(Grid$1, {
    item: true
  }, mockData === null || mockData === void 0 ? void 0 : mockData.secondary.map(function (secondary) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      key: secondary.category
    }, /*#__PURE__*/React.createElement(FluentSecondaryStatNumber, {
      secondaryStat: secondary.value,
      secondaryLabel: secondary.category,
      trend: secondary.value < 0 ? 'down' : 'up'
    }));
  }))), children);
};

var DateTrendWidget$1 = forwardRef(DateTrendWidget);

var DateTrendWidget$2 = {
  __proto__: null,
  layout: layout$2,
  'default': DateTrendWidget$1
};

var layout$3 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var params$2 = {
  mode: {
    defaultValue: 'chart'
  }
};

var DensePlotWidget = function DensePlotWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    variant: "scatterplotChart",
    spec: {
      $schema: 'https://vega.github.io/schema/vega-lite/v4.json',
      description: mockData === null || mockData === void 0 ? void 0 : mockData.description,
      data: {
        values: mockData === null || mockData === void 0 ? void 0 : mockData.data
      },
      mark: 'point',
      height: 180,
      encoding: {
        x: {
          field: 'xAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.xAxisType
        },
        y: {
          field: 'yAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisType
        }
      }
    }
  })), children);
};

var DensePlotWidget$1 = forwardRef(DensePlotWidget);

var DensePlotWidget$2 = {
  __proto__: null,
  layout: layout$3,
  params: params$2,
  'default': DensePlotWidget$1
};

var ChartSummaryToggle = function ChartSummaryToggle(props) {
  var value = props.value,
      onChange = props.onChange;
  var change = useCallback(function (e, value) {
    return onChange && onChange(value);
  }, [onChange]);
  return /*#__PURE__*/React.createElement(ToggleButtonGroup, {
    value: value,
    exclusive: true,
    onChange: change,
    "aria-label": "chart summary mode toggle"
  }, /*#__PURE__*/React.createElement(ToggleButton, {
    name: "chart-summary-mode",
    value: "summary",
    "aria-label": "summary"
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: NumberedListIcon
  })), /*#__PURE__*/React.createElement(ToggleButton, {
    name: "chart-summary-mode",
    value: "chart",
    "aria-label": "chart"
  }, /*#__PURE__*/React.createElement(FluentIcon, {
    component: ChartIcon
  })));
};

var layout$4 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};

var DonutChartWidget = function DonutChartWidget(props, ref) {
  var _mockData$stats;

  var children = props.children,
      params = props.params,
      setParam = props.setParam,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  var body = /*#__PURE__*/React.createElement(Fragment$1, null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "From: ", convertISODate(dateRange.from), " to:", ' ', convertISODate(dateRange.to)), /*#__PURE__*/React.createElement(Grid$1, {
    container: true
  }, mockData === null || mockData === void 0 ? void 0 : (_mockData$stats = mockData.stats) === null || _mockData$stats === void 0 ? void 0 : _mockData$stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      xs: 3,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.currentValue,
      prevAmount: stat.previousValue
    }));
  })), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    variant: "donutChart",
    style: {
      overflow: 'auto',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      padding: 0
    },
    spec: {
      $schema: 'https://vega.github.io/schema/vega/v5.json',
      width: 200,
      height: 200,
      data: [{
        name: 'table',
        values: mockData === null || mockData === void 0 ? void 0 : mockData.data,
        transform: [{
          type: 'pie',
          field: 'value'
        }]
      }, {
        name: 'used',
        source: 'table',
        transform: [{
          type: 'formula',
          expr: "datum.id === 'Other' ? 'Other' : 'Main'",
          as: 'id'
        }, {
          type: 'aggregate',
          fields: ['field'],
          groupby: ['id'],
          ops: ['sum'],
          as: ['sum']
        }, {
          type: 'pivot',
          field: 'label',
          value: 'sum'
        }]
      }],
      scales: [{
        name: 'color',
        type: 'ordinal',
        domain: {
          data: 'table',
          field: 'label'
        },
        range: {
          scheme: 'greys'
        }
      }],
      marks: [{
        type: 'arc',
        from: {
          data: 'table'
        },
        encode: {
          enter: {
            fill: {
              scale: 'color',
              field: 'label'
            },
            x: {
              signal: 'width / 2'
            },
            y: {
              signal: 'height / 2'
            },
            padAngle: {
              value: 0.01
            }
          },
          update: {
            startAngle: {
              field: 'startAngle'
            },
            endAngle: {
              field: 'endAngle'
            },
            innerRadius: {
              signal: 'width / 2 - 10'
            },
            outerRadius: {
              signal: 'width / 2'
            }
          }
        }
      }, {
        type: 'text',
        from: {
          data: 'used'
        },
        style: ['percent'],
        encode: {
          enter: {
            x: {
              signal: 'width / 2'
            },
            y: {
              signal: 'height / 2'
            },
            align: {
              value: 'center'
            },
            baseline: {
              value: 'middle'
            },
            fontSize: {
              value: 24
            }
          }
        }
      }],
      legends: [{
        fill: 'color',
        direction: 'vertical',
        encode: {
          labels: {
            name: 'legendLabel',
            enter: {
              text: {
                field: 'label'
              }
            }
          }
        },
        orient: 'right',
        labelColor: theme === 'dark' ? 'white' : 'rgba(0, 0, 0, 0.87)'
      }]
    }
  })), children);
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    theme: theme,
    ref: ref,
    headerActions: /*#__PURE__*/React.createElement(ChartSummaryToggle, {
      value: params.mode,
      onChange: function onChange(value) {
        return setParam('mode', value);
      }
    })
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title
  }), mockData ? body : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var DonutChartWidget$1 = forwardRef(DonutChartWidget);

var DonutChartWidget$2 = {
  __proto__: null,
  layout: layout$4,
  'default': DonutChartWidget$1
};

var layout$5 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var useStyles$17 = makeStyles(function (theme) {
  return {
    displayItems: {
      display: 'flex',
      flexDirection: 'row',
      width: '100%'
    },
    visualCaption: {
      marginTop: theme.spacing(-1)
    },
    lineGraph: {
      width: '100%',
      '& svg': {
        width: '100%'
      }
    }
  };
});

var LineAndSparklinesWidget = function LineAndSparklinesWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  var classes = useStyles$17();
  var mainTheme = useTheme();
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref,
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }, other), mockData ? /*#__PURE__*/React.createElement("div", null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "From: ", convertISODate(dateRange.from), " to:", ' ', convertISODate(dateRange.to)), /*#__PURE__*/React.createElement("div", {
    className: classes.displayItems
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FluentStatNumber, {
    number: mockData === null || mockData === void 0 ? void 0 : mockData.value,
    trend: "up"
  })), /*#__PURE__*/React.createElement("div", {
    style: {
      width: '100%'
    }
  }, /*#__PURE__*/React.createElement(Sparklines, {
    data: mockData === null || mockData === void 0 ? void 0 : mockData.sparklinesData,
    strokeWidth: 1,
    style: {
      width: '100%',
      height: 45,
      marginTop: 10
    }
  }, /*#__PURE__*/React.createElement(SparklinesLine, {
    color: mainTheme.palette.secondary.main
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.visualCaption
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Divider, null)), /*#__PURE__*/React.createElement(Typography, {
    variant: "caption"
  }, mockData === null || mockData === void 0 ? void 0 : mockData.label)))), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    variant: "areaLineChart",
    style: {
      width: '100%'
    },
    spec: {
      $schema: 'https://vega.github.io/schema/vega-lite/v4.json',
      height: 150,
      data: {
        values: mockData === null || mockData === void 0 ? void 0 : mockData.data
      },
      mark: 'area',
      encoding: {
        x: {
          field: 'xAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.xAxisType
        },
        y: {
          aggregate: 'sum',
          field: 'yAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisType,
          scale: {
            domain: (mockData === null || mockData === void 0 ? void 0 : mockData.domain) || ''
          }
        }
      }
    },
    autoResize: "true",
    width: "container"
  })), children) : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var LineAndSparklinesWidget$1 = forwardRef(LineAndSparklinesWidget);

var LineAndSparklinesWidget$2 = {
  __proto__: null,
  layout: layout$5,
  'default': LineAndSparklinesWidget$1
};

var layout$6 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var params$3 = {
  mode: {
    defaultValue: 'chart'
  }
};

var LineGraphWidget = function LineGraphWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }), mockData ? /*#__PURE__*/React.createElement(Fragment$1, null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "From: ", convertISODate(dateRange.from), " to:", ' ', convertISODate(dateRange.to), ' '), (mockData === null || mockData === void 0 ? void 0 : mockData.stats) && /*#__PURE__*/React.createElement(Grid$1, {
    container: true
  }, mockData === null || mockData === void 0 ? void 0 : mockData.stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      xs: 3,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.currentValue,
      prevAmount: stat.previousValue
    }));
  })), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    variant: "lineChart",
    color: "secondary",
    spec: {
      $schema: 'https://vega.github.io/schema/vega-lite/v4.json',
      description: mockData === null || mockData === void 0 ? void 0 : mockData.description,
      data: {
        values: mockData === null || mockData === void 0 ? void 0 : mockData.data
      },
      mark: 'line',
      encoding: {
        x: {
          field: 'xAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.xAxisType
        },
        y: {
          field: 'yAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisType
        },
        color: {
          field: 'label',
          type: 'nominal',
          legend: {
            direction: 'vertical',
            orient: 'right'
          }
        }
      }
    },
    width: "container",
    height: "container",
    autoResize: "true"
  })), children) : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var LineGraphWidget$1 = forwardRef(LineGraphWidget);

var LineGraphWidget$2 = {
  __proto__: null,
  layout: layout$6,
  params: params$3,
  'default': LineGraphWidget$1
};

var layout$7 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var useStyles$18 = makeStyles(function (theme) {
  return {
    root: {},
    displayItems: {
      display: 'flex',
      flexDirection: 'row',
      justifyContent: 'space-around',
      color: 'white'
    },
    divider: {
      marginTop: theme.spacing(4),
      marginBottom: theme.spacing(2)
    }
  };
});

var ProgressBarWidget = function ProgressBarWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  var classes = useStyles$18();
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    theme: theme,
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    widgetType: "ProgressBarWidget"
  }), mockData ? /*#__PURE__*/React.createElement(Fragment$1, null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "Starting: ", convertISODate(dateRange.from)), /*#__PURE__*/React.createElement(FluentPrimaryStatNumber, {
    mainStat: mockData === null || mockData === void 0 ? void 0 : mockData.value,
    mainLabel: mockData === null || mockData === void 0 ? void 0 : mockData.label
  }), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(LinearProgress, {
    variant: "determinate",
    color: "secondary",
    value: mockData === null || mockData === void 0 ? void 0 : mockData.progress
  }), mockData === null || mockData === void 0 ? void 0 : mockData.progress, "%"), (mockData === null || mockData === void 0 ? void 0 : mockData.data) && /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement("div", {
    className: classes.divider
  }, /*#__PURE__*/React.createElement(Divider, {
    style: {
      background: 'white',
      opacity: 0.5
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.displayItems
  }, mockData === null || mockData === void 0 ? void 0 : mockData.data.map(function (item, index) {
    return /*#__PURE__*/React.createElement(FluentSecondaryStatNumber, {
      secondaryStat: item.value,
      secondaryLabel: item.label,
      trend: item.trend
    });
  }))), children) : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var ProgressBarWidget$1 = forwardRef(ProgressBarWidget);

var ProgressBarWidget$2 = {
  __proto__: null,
  layout: layout$7,
  'default': ProgressBarWidget$1
};

var layout$8 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var useStyles$19 = makeStyles(function (theme) {
  return {
    statList: {
      display: 'flex',
      flexDirection: 'row',
      justifyContent: 'space-between'
    }
  };
});

var SparklineWidget = function SparklineWidget(props, ref) {
  var _mockData$stats;

  var classes = useStyles$19();

  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme,
      dateRange = params.dateRange;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    className: classes.root,
    theme: theme,
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title
  }), mockData ? /*#__PURE__*/React.createElement(Fragment$1, null, dateRange && /*#__PURE__*/React.createElement(Typography, {
    gutterBottom: true,
    variant: "caption",
    component: "h3"
  }, "From: ", convertISODate(dateRange.from), " to:", ' ', convertISODate(dateRange.to)), /*#__PURE__*/React.createElement("div", {
    className: classes.statList
  }, mockData === null || mockData === void 0 ? void 0 : (_mockData$stats = mockData.stats) === null || _mockData$stats === void 0 ? void 0 : _mockData$stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.amount,
      percent: stat.percent && stat.percent,
      trend: stat.trend
    }));
  })), /*#__PURE__*/React.createElement(Sparklines, {
    data: mockData === null || mockData === void 0 ? void 0 : mockData.data,
    strokeWidth: 0.5
  }, /*#__PURE__*/React.createElement(SparklinesLine, {
    color: "#067e7e"
  })), children) : /*#__PURE__*/React.createElement(Typography, {
    variant: "subtitle2"
  }, "Could not retrieve widget data. Please contact support."));
};

var SparklineWidget$1 = forwardRef(SparklineWidget);

var SparklineWidget$2 = {
  __proto__: null,
  layout: layout$8,
  'default': SparklineWidget$1
};

var layout$9 = {
  w: {
    "default": 2,
    min: 0,
    max: 4
  },
  h: {
    "default": 2,
    min: 0,
    max: 4
  }
};
var params$4 = {
  mode: {
    defaultValue: 'chart'
  }
};

var SparsePlotWidget = function SparsePlotWidget(props, ref) {
  var children = props.children,
      params = props.params,
      other = _objectWithoutPropertiesLoose(props, ["children", "params", "setParam"]);

  var mockData = params.mockData,
      theme = params.theme;
  return /*#__PURE__*/React.createElement(WidgetCard, _extends({
    ref: ref
  }, other, {
    title: mockData === null || mockData === void 0 ? void 0 : mockData.title,
    theme: theme
  }), /*#__PURE__*/React.createElement(Grid$1, {
    container: true
  }, mockData === null || mockData === void 0 ? void 0 : mockData.stats.map(function (stat) {
    return /*#__PURE__*/React.createElement(Grid$1, {
      item: true,
      xs: 3,
      key: stat.label
    }, /*#__PURE__*/React.createElement(FluentStatsSnippet, {
      label: stat.label,
      amount: stat.currentValue,
      prevAmount: stat.previousValue
    }));
  })), /*#__PURE__*/React.createElement(Box, {
    clone: true,
    flex: 1,
    mt: 1,
    overflow: "hidden"
  }, /*#__PURE__*/React.createElement(MuiVegaLite, {
    spec: {
      $schema: 'https://vega.github.io/schema/vega-lite/v4.json',
      width: 'container',
      height: 'container',
      data: mockData === null || mockData === void 0 ? void 0 : mockData.data,
      mark: {
        type: 'point',
        line: true,
        point: true
      },
      encoding: {
        x: {
          field: 'xAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.xAxisType
        },
        y: {
          field: 'yAxis',
          type: mockData === null || mockData === void 0 ? void 0 : mockData.yAxisType
        }
      }
    },
    variant: "scatterplotChart",
    autoResize: true,
    actions: false
  })), children);
};

var SparsePlotWidget$1 = forwardRef(SparsePlotWidget);

var SparsePlotWidget$2 = {
  __proto__: null,
  layout: layout$9,
  params: params$4,
  'default': SparsePlotWidget$1
};

var ExpansionPanel = withStyles(function (theme) {
  return {
    root: {
      boxShadow: 'none',
      minWidth: 300,
      '&:not(:last-child)': {
        borderBottom: 0
      },
      '&$expanded': {
        margin: 'auto',
        backgroundColor: lighten(theme.palette.primary.light, 0.3)
      }
    },
    expanded: {}
  };
})(MuiExpansionPanel);
var ExpansionPanelSummary = withStyles(function (theme) {
  return {
    root: {
      backgroundColor: lighten(theme.palette.primary.light, 0.9),
      marginBottom: -1,
      minHeight: 40,
      '&$expanded': {
        minHeight: 40,
        backgroundColor: lighten(theme.palette.primary.light, 0.7)
      }
    },
    content: {
      '&$expanded': {
        margin: '12px 0'
      }
    },
    expanded: {}
  };
})(MuiExpansionPanelSummary);
var ExpansionPanelDetails = withStyles(function (theme) {
  return {
    root: {
      padding: theme.spacing(2)
    }
  };
})(MuiExpansionPanelDetails);
var Block = function Block(_ref) {
  var label = _ref.label,
      children = _ref.children,
      number = _ref.number,
      id = _ref.id;

  var _useState = useState('panel1'),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var handleChange = function handleChange(panel) {
    return function (event, newExpanded) {
      setExpanded(newExpanded ? panel : false);
    };
  };

  return /*#__PURE__*/React.createElement(ExpansionPanel, {
    square: true,
    expanded: expanded === "panel" + number,
    onChange: handleChange("panel" + number),
    id: id
  }, /*#__PURE__*/React.createElement(ExpansionPanelSummary, {
    "aria-controls": "panel3d-content"
  }, /*#__PURE__*/React.createElement(Typography$1, {
    variant: "subtitle2"
  }, label)), /*#__PURE__*/React.createElement(ExpansionPanelDetails, null, children));
};

var useStyles$1a = makeStyles(function (theme) {
  return {
    root: {
      padding: 0,
      justifyContent: 'left'
    },
    wrapper: {
      minWidth: 200,
      width: '100%'
    },
    item: {
      height: theme.spacing(1)
    },
    label: {
      textTransform: 'none'
    }
  };
});
var FluentMenuListItem = function FluentMenuListItem(_ref) {
  var label = _ref.label,
      onClick = _ref.onClick,
      props = _objectWithoutPropertiesLoose(_ref, ["label", "onClick"]);

  var classes = useStyles$1a();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.wrapper
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.item
  }), /*#__PURE__*/React.createElement(Button, _extends({}, props, {
    fullWidth: true,
    classes: {
      root: classes.root,
      label: classes.label
    },
    onClick: onClick
  }), label), /*#__PURE__*/React.createElement("div", {
    className: classes.item
  }), /*#__PURE__*/React.createElement(Divider, null));
};

var useStyles$1b = makeStyles(function (theme) {
  return {
    root: {},
    wrapper: {
      display: 'flex',
      flexDirection: 'row',
      padding: theme.spacing(1),
      lineHeight: 2
    },
    value: {
      flex: 1
    }
  };
});
var FluentListElement = function FluentListElement(_ref) {
  var subject = _ref.subject,
      value = _ref.value,
      className = _ref.className,
      status = _ref.status;
  var classes = useStyles$1b();
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(classes.root, className)
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.wrapper
  }, /*#__PURE__*/React.createElement(Typography, {
    className: classes.value,
    variant: "body2"
  }, subject, ":"), status && /*#__PURE__*/React.createElement(StatusChip$1, {
    status: status,
    label: value
  }), !status && /*#__PURE__*/React.createElement(Typography, {
    variant: "body2"
  }, /*#__PURE__*/React.createElement("strong", null, value))), /*#__PURE__*/React.createElement(Divider, null));
};

var useStyles$1c = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'row',
      width: '100%',
      position: 'relative'
    },
    column: {
      display: 'flex',
      flexDirection: 'row',
      flex: 1
    },
    content: {
      flex: 1
    },
    sideBar: {
      height: '100vh',
      background: theme.palette.primary.light
    }
  };
});
var SideBarTemplate = function SideBarTemplate(_ref) {
  var children = _ref.children,
      sidebar = _ref.sidebar;
  var classes = useStyles$1c();

  var _useState = useState(true),
      open = _useState[0],
      setOpen = _useState[1];

  var toggleSidebar = function toggleSidebar() {
    setOpen(!open);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.column
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.content
  }, children), /*#__PURE__*/React.createElement("div", {
    style: {
      position: 'absolute',
      top: 0,
      right: open ? 300 : 0
    }
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    color: "primary",
    icon: open ? ChevronRightIcon : ChevronLeftIcon,
    onClick: toggleSidebar
  })), open && /*#__PURE__*/React.createElement(Fade, {
    "in": open,
    timeout: {
      enter: 1000,
      exit: 1000
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.sideBar
  }, sidebar))));
};

var useStyles$1d = makeStyles(function (theme) {
  return {
    root: {
      flex: 1,
      display: 'flex',
      flexDirection: 'column'
    }
  };
}, {
  name: 'PageContent'
});
var OpenPage = function OpenPage(props) {
  var classes = useStyles$1d(props);

  var className = props.className,
      children = props.children,
      _props$maxWidth = props.maxWidth,
      maxWidth = _props$maxWidth === void 0 ? false : _props$maxWidth,
      _props$disableGutters = props.disableGutters,
      disableGutters = _props$disableGutters === void 0 ? false : _props$disableGutters,
      other = _objectWithoutPropertiesLoose(props, ["className", "children", "maxWidth", "disableGutters"]);

  return /*#__PURE__*/React.createElement(Container, _extends({}, other, {
    classes: null,
    className: clsx(className, classes.root),
    maxWidth: maxWidth,
    disableGutters: disableGutters
  }), children);
};

var SapFlexibleTemplate = function SapFlexibleTemplate(_ref) {
  var left = _ref.left,
      center = _ref.center,
      right = _ref.right;

  var _useState = useState({
    columnLeft: true,
    columnCenter: true,
    columnRight: true
  }),
      columns = _useState[0],
      setColumns = _useState[1];

  var _useState2 = useState({
    columnLeft: '25%',
    columnCenter: '50%',
    columnRight: '25%'
  }),
      columnPercent = _useState2[0],
      setColumnPercent = _useState2[1];

  var useStyles = makeStyles(function (theme) {
    return {
      root: {
        display: 'flex',
        flexDirection: 'row'
      },
      columnLeft: {
        display: 'flex',
        flex: columnPercent.columnLeft,
        height: '100vh'
      },
      columnCenter: {
        flex: columnPercent.columnCenter,
        height: '100vh'
      },
      columnRight: {
        display: 'flex',
        flex: columnPercent.columnRight,
        height: '100vh'
      },
      fillContent: {
        flex: 1
      }
    };
  });
  var classes = useStyles();

  var handleToggleColumn = function handleToggleColumn(columnType) {
    setColumns(_extends({}, columns, {
      columnCenter: !columns.columnCenter
    }));

    if (columnType === 'columnLeft') {
      setColumnPercent(_extends({}, columnPercent, {
        columnLeft: '75%'
      }));

      if (columnPercent.columnLeft === '75%') {
        setColumnPercent(_extends({}, columnPercent, {
          columnLeft: '25%'
        }));
      }
    } else {
      setColumnPercent(_extends({}, columnPercent, {
        columnRight: '75%'
      }));

      if (columnPercent.columnRight === '75%') {
        setColumnPercent(_extends({}, columnPercent, {
          columnRight: '25%'
        }));
      }
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, columns.columnLeft && /*#__PURE__*/React.createElement("div", {
    className: classes.columnLeft
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.fillContent
  }, left, " "), /*#__PURE__*/React.createElement("div", {
    className: classes.toggle
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    "aria-label": columnPercent.columnLeft === '25%' ? 'Expand column' : 'Collapse column',
    color: "primary",
    icon: columnPercent.columnLeft === '25%' ? ChevronRightIcon : ChevronLeftIcon,
    onClick: function onClick() {
      return handleToggleColumn('columnLeft');
    }
  }))), columns.columnCenter && /*#__PURE__*/React.createElement("div", {
    className: classes.columnCenter
  }, /*#__PURE__*/React.createElement("div", null, " ", center, " ")), columns.columnRight && /*#__PURE__*/React.createElement("div", {
    className: classes.columnRight
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.toggle
  }, /*#__PURE__*/React.createElement(FluentIconButton$1, {
    "aria-label": columnPercent.columnRight === '25%' ? 'Expand column' : 'Collapse column',
    color: "primary",
    icon: columnPercent.columnRight === '25%' ? ChevronLeftIcon : ChevronRightIcon,
    onClick: function onClick() {
      return handleToggleColumn('columnRight');
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.fillContent
  }, " ", right, " ")));
};

function a11yProps$1(index) {
  return {
    id: "simple-tab-" + index,
    'aria-controls': "simple-tabpanel-" + index
  };
}

var useStyles$1e = makeStyles(function (theme) {
  return {
    root: {
      flexGrow: 1,
      marginTop: 12
    },
    title: {
      margin: theme.spacing(2)
    },
    titleWrapper: {
      paddingLeft: theme.spacing(2)
    }
  };
});
var UtilityTabHeader = function UtilityTabHeader(_ref) {
  var handleChange = _ref.handleChange,
      value = _ref.value,
      tabList = _ref.tabList,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? 'Page title' : _ref$title;
  var classes = useStyles$1e();
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement("div", {
    className: classes.titleWrapper
  }, /*#__PURE__*/React.createElement(StandardTitle$1, null, title)), /*#__PURE__*/React.createElement(FluentSimpleTabs$1, {
    value: value,
    onChange: handleChange
  }, tabList && tabList.map(function (item, index) {
    return /*#__PURE__*/React.createElement(FluentSimpleTab$1, _extends({
      key: item.label,
      label: item.label
    }, a11yProps$1(index)));
  })));
};

var useStyles$1f = makeStyles(function (theme) {
  return {
    root: {
      width: theme.dimensions.drawerWidth,
      flexShrink: 0,
      whiteSpace: 'nowrap'
    },
    expanded: {
      '&, & > $paper': {
        width: theme.spacing(32),
        transition: theme.transitions.create('width', {
          easing: theme.transitions.easing.sharp,
          duration: theme.transitions.duration.enteringScreen
        })
      }
    },
    collapsed: {
      '&, & > $paper': {
        overflowX: 'hidden',
        width: theme.spacing(7) + 1,
        transition: theme.transitions.create('width', {
          easing: theme.transitions.easing.sharp,
          duration: theme.transitions.duration.leavingScreen
        })
      }
    },
    paper: {}
  };
}, {
  name: 'MiniCollapsibleSidebar'
});

var MiniCollapsibleSidebar = function MiniCollapsibleSidebar(props) {
  var classes = useStyles$1f(props);

  var _props$expanded = props.expanded,
      expanded = _props$expanded === void 0 ? true : _props$expanded,
      className = props.className,
      children = props.children,
      other = _objectWithoutPropertiesLoose(props, ["expanded", "className", "children"]);

  return /*#__PURE__*/React.createElement(Drawer, _extends({
    variant: "permanent",
    open: true
  }, other, {
    className: clsx(className, classes.root, expanded ? classes.expanded : classes.collapsed),
    classes: {
      root: classes.root,
      paper: classes.paper
    }
  }), children);
};

var useStyles$1g = makeStyles(function (theme) {
  return {
    root: {
      display: 'flex',
      justifyContent: 'flex-start',
      height: 48,
      width: '100%',
      paddingLeft: 0,
      paddingRight: 16
    },
    iconButton: {
      width: 48,
      height: 48,
      marginLeft: 16 - (48 - 24) / 2
    },
    expanded: {},
    icon: {
      width: 14,
      height: 14,
      margin: (24 - 16) / 2,
      transition: theme.transitions.create('transform', {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.shortest
      }),
      '$expanded &': {
        transform: 'scaleX(-1)'
      }
    },
    "switch": {
      margin: (24 - 16) / 2,
      transition: theme.transitions.create('transform', {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.shortest
      }),
      '$expanded &': {
        transform: 'scaleX(-1)'
      }
    }
  };
}, {
  name: 'SidebarCollapseButton'
});
var SidebarCollapseButton = function SidebarCollapseButton(props) {
  var _clsx;

  var classes = useStyles$1g(props);

  var expanded = props.expanded,
      className = props.className,
      other = _objectWithoutPropertiesLoose(props, ["expanded", "className"]);

  var _useTranslation = useTranslation(),
      t = _useTranslation.t;

  return /*#__PURE__*/React.createElement("div", _extends({}, other, {
    className: clsx(className, classes.root, (_clsx = {}, _clsx[classes.expanded] = expanded, _clsx))
  }), /*#__PURE__*/React.createElement(FluentIconButton$1, {
    color: "inherit",
    className: clsx(classes.iconButton, classes["switch"]),
    "aria-label": expanded ? t('mainMenuAria.collapseNavigation') : t('mainMenuAria.expandNavigation'),
    icon: ChevronRightIcon
  }));
};

var useStyles$1h = makeStyles(function (theme) {
  return {
    root: {
      marginTop: 400
    },
    paper: {
      backgroundColor: lighten(theme.palette.primary.main, 0.9)
    },
    list: {
      flex: 1,
      paddingTop: 0,
      overflowY: 'auto',
      WebkitOverflowScrolling: 'touch'
    },
    spacer: {
      flex: 1,
      minHeight: theme.spacing(2)
    },
    footer: {},
    toolbar: {}
  };
}, {
  name: 'NavigationSidebar'
});

var NavigationSidebar = function NavigationSidebar(props) {
  var classes = useStyles$1h();

  var data = props.data,
      other = _objectWithoutPropertiesLoose(props, ["data"]);

  var theme = useTheme();

  var _useState = useState(true),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var _useState2 = useState(false),
      hoverExpand = _useState2[0],
      setHoverExpand = _useState2[1];

  var wide = useMediaQuery(theme.breakpoints.up('sm'));
  useEffect(function () {
    setExpanded(wide);
  }, [wide]);

  var handleHoverToggle = function handleHoverToggle() {
    if (!expanded) {
      setHoverExpand(true);
    }
  };

  var handleHoverLeave = function handleHoverLeave() {
    if (!expanded) {
      setHoverExpand(false);
    }
  };

  return /*#__PURE__*/React.createElement(MiniCollapsibleSidebar, _extends({
    classes: {
      root: classes.root,
      paper: classes.paper
    },
    expanded: expanded || hoverExpand,
    onMouseEnter: handleHoverToggle,
    onMouseLeave: handleHoverLeave,
    PaperProps: {
      elevation: 0,
      variant: 'outlined'
    }
  }, other), /*#__PURE__*/React.createElement(Toolbar, {
    className: classes.toolbar
  }), /*#__PURE__*/React.createElement(SidebarCollapseButton, {
    expanded: expanded,
    onClick: function onClick() {
      return setExpanded(function (expanded) {
        return !expanded;
      });
    }
  }), data && /*#__PURE__*/React.createElement(AppMenu$1, {
    menuItems: data
  }));
};

var useStyles$1i = makeStyles(function (theme) {
  return {
    root: {
      color: theme.palette.appBar.contrastText,
      zIndex: theme.zIndex.drawer + 1
    },
    spacer: {
      flex: 1
    },
    toolbar: _extends({}, theme.mixins.toolbar),
    appLaunch: {
      color: theme.palette.getContrastText(theme.palette.primary.main)
    },
    avatar: {
      width: 25,
      height: 25,
      backgroundColor: theme.palette.secondary.main
    },
    search: {
      marginLeft: theme.spacing(2),
      marginTop: theme.spacing(-1.35)
    },
    children: {
      flex: 1
    }
  };
}, {
  name: 'SiteHeader'
});
var SiteHeaderSpacer = function SiteHeaderSpacer(props) {
  var classes = useStyles$1i();
  var className = props.className;
  return /*#__PURE__*/React.createElement("div", {
    className: clsx(className, classes.toolbar)
  });
};

var SiteHeader = function SiteHeader(props) {
  var classes = useStyles$1i(props);

  var className = props.className,
      appContent = props.appContent,
      userAvatar = props.userAvatar,
      siteName = props.siteName,
      other = _objectWithoutPropertiesLoose(props, ["className", "returnTo", "appContent", "userAvatar", "siteName"]);

  return /*#__PURE__*/React.createElement(Fragment$1, null, /*#__PURE__*/React.createElement(AppBar, _extends({
    elevation: 0,
    position: "absolute",
    color: "primary"
  }, other, {
    className: className,
    classes: {
      root: classes.root
    }
  }), /*#__PURE__*/React.createElement(Toolbar, null, /*#__PURE__*/React.createElement(IconButton, {
    className: classes.appLaunch,
    "aria-label": "App Launcher Menu"
  }, /*#__PURE__*/React.createElement(WaffleIcon, null)), /*#__PURE__*/React.createElement(Typography, {
    component: "h1",
    variant: "h6"
  }, siteName), /*#__PURE__*/React.createElement("div", {
    style: {
      marginLeft: 70
    }
  }, /*#__PURE__*/React.createElement(BreadCrumbMenu$1, {
    color: "primary",
    root: "home"
  })), /*#__PURE__*/React.createElement("div", {
    className: classes.children
  }, appContent), /*#__PURE__*/React.createElement("div", null, userAvatar))), /*#__PURE__*/React.createElement(SiteHeaderSpacer, {
    className: className
  }));
};

var useStyles$1j = makeStyles(function (theme) {
  return {
    '@global': {
      html: {
        minHeight: '100%'
      },
      'html, body, #root': {
        display: 'flex',
        flexDirection: 'column'
      },
      'body, #root': {
        flex: 1
      }
    },
    root: {
      flex: 1,
      minHeight: '100vh',
      display: 'grid',
      gridTemplateAreas: ['sidebar header', 'sidebar content'].map(function (line) {
        return "\"" + line + "\"";
      }).join(' '),
      gridTemplateColumns: 'auto 1fr',
      gridTemplateRows: 'auto 1fr'
    },
    header: {
      gridArea: 'header'
    },
    sidebar: {
      gridArea: 'sidebar'
    },
    content: {
      gridArea: 'content',
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      zIndex: 1
    },
    utilityBar: {
      height: 100
    }
  };
}, {
  name: 'Layout'
});
var Shell = function Shell(props) {
  var classes = useStyles$1j();
  var children = props.children,
      userAvatar = props.userAvatar,
      appContent = props.appContent,
      menuList = props.menuList,
      siteName = props.siteName;

  var _useState = useState(true),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var _useTranslation = useTranslation(),
      i18n = _useTranslation.i18n;

  useEffect(function () {
    i18n.changeLanguage('en');
  }, [i18n]);
  return /*#__PURE__*/React.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/React.createElement(SiteHeader, {
    className: classes.header,
    siteName: siteName,
    appContent: appContent,
    userAvatar: userAvatar
  }), /*#__PURE__*/React.createElement(NavigationSidebar, {
    className: classes.sidebar,
    data: menuList
  }), /*#__PURE__*/React.createElement("div", {
    className: classes.content
  }, /*#__PURE__*/React.createElement(UtilityBar$1, {
    toggle: function toggle() {
      return setExpanded(function (expanded) {
        return !expanded;
      });
    },
    expanded: expanded,
    className: classes.utilityBar,
    gutters: false
  }), children));
};

export { AddressListItem, AppMenu, AppMenuItem, AppMenuItemComponent, AppMenuItemPropTypes, AvatarAlphabet, BarChartWidget$2 as BarChartWidget, BaseSideSheet, BioCard, Block, BreadCrumbMenu, BubbleWidget$2 as BubbleWidget, ChipAlphabet, Controls$1 as Controls, DateTrendWidget$2 as DateTrendWidget, DensePlotWidget$2 as DensePlotWidget, Directory, DirectoryListItem, DonutChartWidget$2 as DonutChartWidget, ExpansionPanel, ExpansionPanelDetails, ExpansionPanelSummary, FileUpload, FluentActivity, FluentActivityRow, FluentButton, FluentCard, FluentCheckbox, FluentCompoundButton, FluentDialog, FluentIcon, FluentIconButton, FluentLink, FluentListElement, FluentMenuListItem, FluentSelectGroupMenu, FluentSelectMenu, FluentSideNav, FluentSimpleTab, FluentSimpleTabs, FluentTabPanel, FluentTabUtility, FluentTextField, FluentToggle, FluentUploadButton, FluentUploadIconButton, FormHeader, FormSubHeader, FullScreenControl$1 as FullScreenControl, GeoMap, GridGroup, GridRow$1 as GridRow, GridUnit$1 as GridUnit, ImageLayer, InfoCard, Layers$1 as Layers, LayoutUnit, LineAndSparklinesWidget$2 as LineAndSparklinesWidget, LineGraphWidget$2 as LineGraphWidget, Map$1 as Map, MapFilterBar, MapSheet, Note, Notes, OpenPage, PageNotFound, ProgressBarWidget$2 as ProgressBarWidget, SapFlexibleTemplate, SelectGroupMenu, Shell, SideBarTemplate, SideSheet, SideSheetHeader, SparklineWidget$2 as SparklineWidget, SparsePlotWidget$2 as SparsePlotWidget, StandardTitle, StatusChip, SubHeaderAction, SubHeaderActionsTarget, TileDisplay, TileLayer$1 as TileLayer, ToolBarButton, TrimForAvatar, UtilityBar, UtilityTabHeader, VectorLayer, getMenuItemsRecursively, getRatio$1 as getRatio, useControlZoom, usePosition, useStyles$O as useStyles, useTypeScale, verticalPrimary, verticalSecondary };
//# sourceMappingURL=index.modern.js.map
